/**************************************************************************\
*
* Copyright (c)  Ųʽ. All Rights Reserved.
*
* Ųʽ - ٷվ : http://www.xcgui.com
*
\**************************************************************************/
#pragma once

//v1.8.2
//////////////////////
#define in_
#define out_
#define in_out_
#define XC_API extern "C"


#define  XC_NAME    _T("name")
#define  XC_NAME2   _T("name2")
#define  XC_NAME3   _T("name3")
#define  XC_NAME4   _T("name4")
#define  XC_NAME5   _T("name5")
#define  XC_NAME6   _T("name6")


/// @defgroup groupObjectType ӿھ
/// @ingroup macroDefine
/// @{
/// Ųʶ
enum XC_OBJECT_TYPE  ///<Ųʶ
{
	XC_ERROR =-1,      ///<
	XC_WINDOW = 1,     ///<
	XC_MODALWINDOW ,   ///<ģ̬
	XC_FRAMEWND    ,   ///<ܴ
	XC_FLOATWND     ,  ///<
	XC_COMBOBOXWINDOW   =   11,   //comboBoxWindow_        Ͽ򵯳б
	XC_POPUPMENUWINDOW  ,         //popupMenuWindow_       ˵
	XC_POPUPMENUCHILDWINDOW ,     //popupMenuChildWindow_  ˵Ӵ

	//Ԫ
	XC_ELE      = 21, ///<Ԫ
	XC_BUTTON   ,     ///<ť
	XC_RICHEDIT   ,   ///<ı༭
	XC_COMBOBOX    ,  ///<ϿԪ
	XC_SCROLLBAR   ,  ///<Ԫ
	XC_SCROLLVIEW  ,  ///<ͼԪ
	XC_LIST        ,  ///<бԪ
	XC_LISTBOX    ,   ///<бԪ
	XC_LISTVIEW      ,  ///<бͼ,ͼ
	XC_TREE       ,  ///<Ԫ
	XC_MENUBAR    ,  ///<˵
	XC_SLIDERBAR     ,  ///<
	XC_PROGRESSBAR   ,  ///<
	XC_TOOLBAR       ,  ///<
	XC_MONTHCAL      ,  ///<Ԫ
	XC_DATETIME      ,  ///<ʱԪ
	XC_PROPERTYGRID  ,  ///<
	XC_RICHEDIT_COLOR   ,  ///<ɫѡԪ
	XC_RICHEDIT_SET,
	XC_TABBAR,   ///<tab
	XC_TEXTLINK, ///<ıӰť

	XC_PANE          ,  ///<ִ
	XC_PANE_SPLIT    ,  ///<ִ϶ָ
	XC_MENUBAR_BUTTON       ,   ///<˵ϵİť
	XC_TOOLBAR_BUTTON       ,   ///<ϰť
	XC_PROPERTYPAGE_LABEL   ,   ///<ҳǩť
	XC_PIER                 ,  ///<ͣͷ
	XC_BUTTON_MENU          ,   ///<˵ť
	XC_VIRTUAL_ELE          ,   ///<Ԫ
	XC_RICHEDIT_FILE        ,   ///<RichEditFile ļѡ༭
	XC_RICHEDIT_FOLDER      ,   ///<RichEditFolder  ļѡ༭
	XC_LIST_HEADER          ,   ///<бͷԪ

	XC_SHAPE       =61,  ///<״
	XC_TEXT_BLOCK,       ///<״-ı
	XC_SHAPE_PICTURE,    ///<״-ͼƬ
	XC_SHAPE_RECT,       ///<״-
	XC_SHAPE_ELLIPSE,    ///<״-Բ
	XC_SHAPE_LINE,       ///<״-ֱ
	XC_SHAPE_GROUPBOX,   ///<״-

	//
	XC_MENU       = 81,  ///<˵
	XC_IMAGE         ,  ///<ͼƬ
	XC_HDRAW         ,  ///<ͼ
	XC_FONT          ,  ///<Ų
	XC_FLASH         ,  ///<flash   
	XC_PANE_CELL     ,  
	XC_WEB           ,

	XC_LAYOUT_OBJECT = 101,
	XC_ADAPTER_TABLE    ,
	XC_ADAPTER_TREE     ,
	XC_ADAPTER_LISTVIEW ,
	XC_ADAPTER_MAP,

	//ʵ,ֻжϲ
	XC_LAYOUT_LISTVIEW     = 111,
	XC_LAYOUT_LIST     ,
	XC_LAYOUT_OBJECT_GROUP ,
	XC_LAYOUT_OBJECT_ITEM  ,
	XC_LAYOUT_PANEL,
};

///@}

//#ifdef _DEBUG
#define DECLARE_HANDLEX(name) struct name##__ { int unused; }; typedef struct name##__ *name
//#else
//#define	DECLARE_HANDLEX(name) typedef void* name
//#endif

/// @defgroup groupHandle б
/// @ingroup macroDefine
/// @{
typedef void*   HXCGUI;   ///<Դ
DECLARE_HANDLEX(HWINDOW); ///<Դ
DECLARE_HANDLEX(HELE);    ///<ԪԴ
DECLARE_HANDLEX(HMENUX);  ///<˵Դ
DECLARE_HANDLEX(HSTRING); ///<ַԴ
DECLARE_HANDLEX(HDRAW);   ///<ͼλԴ
DECLARE_HANDLEX(HARRAY);  ///<Դ
DECLARE_HANDLEX(HIMAGE);  ///<ͼƬԴ
DECLARE_HANDLEX(HXMLRES); ///<XMLԴ
DECLARE_HANDLEX(HARRAY_ITERATOR); ///<
DECLARE_HANDLEX(HFONTX);    ///<Ų
DECLARE_HANDLEX(HPANE_GROUP); ///<
///@}

//ʽ----------------------------
/// @defgroup groupWindowStyle Ųʴʽ
/// @ingroup macroDefine
/// @{
#define  XC_SY_CAPTION             0x00000001  ///<top,ָ,ĬΪ󶨱Ԫ
#define  XC_SY_BORDER              0x00000002  ///<߿,ָĬҲִС,ûָ,ô߿򲼾ִСΪ0
#define  XC_SY_CENTER              0x00000004  ///<ھ
#define  XC_SY_DRAG_BORDER         0x00000008  ///<϶ڱ߿
#define  XC_SY_DRAG_WINDOW         0x00000010  ///<϶

///Ĭʽ
#define  XC_SY_DEFAULT (XC_SY_CAPTION | \
	XC_SY_BORDER | \
	XC_SY_CENTER | \
	XC_SY_DRAG_BORDER)

///ģ̬
#define  XC_SY_MODAL_WINDOW (XC_SY_CAPTION | XC_SY_CENTER |  XC_SY_BORDER)

///@}

#ifdef _DEBUG
#define XTRACE   xtrace
#define XTRACEW  xtracew
#define XERROR   XTRACE 
#define XERRORW  XTRACEW
#else
#define XTRACE
#define XTRACEW
#define XERROR 
#define XERRORW
#endif

#define  XC_WINDOW_TOP            1 //
#define  XC_WINDOW_BOTTOM         2 //
#define  XC_WINDOW_LEFT           3 //
#define  XC_WINDOW_RIGHT          4 //
#define  XC_WINDOW_TOPLEFT        5 //Ͻ
#define  XC_WINDOW_TOPRIGHT       6 //Ͻ
#define  XC_WINDOW_BOTTOMLEFT     7 //½
#define  XC_WINDOW_BOTTOMRIGHT    8 //½
#define  XC_WINDOW_CAPTION        9 //ƶ
#define  XC_WINDOW_BODY           10

/// @defgroup groupWindowLayout_pos ڲλ
/// @ingroup macroDefine
/// @{
#define  XC_LAYOUT_TOP           1  ///<top
#define  XC_LAYOUT_BOTTOM        2	///<bottom
#define  XC_LAYOUT_LEFT          3	///<left
#define  XC_LAYOUT_RIGHT         4	///<right
#define  XC_LAYOUT_BODY          5	///<body

///@}

//͸
/// @defgroup groupWindowTransparent Ųʴ͸ʶ
/// @ingroup macroDefine
/// @{
#define XC_WIND_TRANSPARENT_NO       0 ///<Ĭϴ,͸
#define XC_WIND_TRANSPARENT_SHAPED   1 ///<͸,͸ͨ,.
#define XC_WIND_TRANSPARENT_SHADOW   2 ///<Ӱ,͸ͨ,߿Ӱ,͸͸,ǰδ.
#define XC_WIND_TRANSPARENT_SIMPLE   4 ///<͸,͸ͨ,ָ͸,ָ͸ɫ.
#define XC_WIND_TRANSPARENT_WIN7     8 ///<WIN7,ҪWIN7Ч,ǰδ.

///@}

/// @defgroup groupID_fixed  ID
/// @ingroup macroDefine
/// @{
#define  XC_ID_ROOT            0   ///<ڵ
#define  XC_ID_ERROR          -1   ///<ID
#define  XC_ID_FIRST          -2   ///<뿪ʼλ
#define  XC_ID_LAST           -3   ///<ĩβλ

/// @}


/// @defgroup groupMenu ˵
/// @ingroup macroDefine
/// @{

//˵ʶ
///@name ˵ʶ
///@{
#define  XM_SELECT      1   ///<ѡ
#define  XM_DISABLED    2   ///<
#define  XM_CHECK       4   ///<ѡ
#define  XM_POPUP       8   ///<
#define  XM_SEPARATOR   16  ///<ָ ID,IDű

///@}

//˵
///@name ˵
///@{
#define  XM_LEFT_TOP       0   ///<Ͻ
#define  XM_LEFT_BOTTOM    1   ///<½
#define  XM_RIGHT_TOP      2   ///<Ͻ
#define  XM_RIGHT_BOTTOM   3   ///<½
#define  XM_CENTER_LEFT    4   ///<
#define  XM_CENTER_TOP     5   ///<Ͼ
#define  XM_CENTER_RIGHT   6   ///<Ҿ
#define  XM_CENTER_BOTTOM  7   ///<¾

///@}

//˵ID--------------------------------------
///@name ˵ID
///@{
#define  IDM_CLIP          1000000000    ///<
#define  IDM_COPY          1000000001    ///<
#define  IDM_PASTE         1000000002    ///<ճ
#define  IDM_DELETE        1000000003    ///<ɾ
#define  IDM_SELECTALL     1000000004    ///<ȫѡ
#define  IDM_DELETEALL     1000000005    ///<

///@}

///@}

/// @defgroup groupImageDrawType ͼƬ
/// @ingroup macroDefine
/// @{
#define XC_IMAGE_DEFAULT  0  ///<Ĭ
#define XC_IMAGE_STRETCH  1  ///<
#define XC_IMAGE_ADAPTIVE 2  ///<Ӧ
#define XC_IMAGE_TILE     3  ///<ƽ

///@}


//״̬--------------------------------------
/// @defgroup groupButtonState ť״̬
/// @ingroup  macroDefine
/// @{
#define  STATE_LEAVE   0   ///<뿪
#define  STATE_DOWN    1   ///<
#define  STATE_STAY    2   ///<ͣ

///@}

/// @defgroup groupButtonType ť(ֹ)
/// @ingroup macroDefine
/// @{
#define  XC_BUTTON_TYPE_DEFAULT  0 ///<Ĭ
#define  XC_BUTTON_TYPE_CHECK    1 ///<ѡť
#define  XC_BUTTON_TYPE_RADIO    2 ///<ѡť
#define  XC_BUTTON_TYPE_CLOSE    3 ///<ڹرհť
#define  XC_BUTTON_TYPE_MIN      4 ///<Сť
#define  XC_BUTTON_TYPE_MAX      5 ///<󻯻ԭť

///@}

/// @defgroup groupButtonStyle ťʽ()
/// @ingroup macroDefine
/// @{
#define  XC_BUTTON_STYLE_DEFAULT          0  ///<ĬϷ
#define  XC_BUTTON_STYLE_CHECK            1  ///<ѡť
#define  XC_BUTTON_STYLE_RADIO            2  ///<ѡť
#define  XC_BUTTON_STYLE_SCROLLBAR_UP     3  ///<ˮƽ,ϰť
#define  XC_BUTTON_STYLE_SCROLLBAR_DOWN   4  ///<ˮƽ,°ť
#define  XC_BUTTON_STYLE_SCROLLBAR_LEFT   5  ///<ˮƽ,ť
#define  XC_BUTTON_STYLE_SCROLLBAR_RIGHT  6  ///<ˮƽ,Ұť
#define  XC_BUTTON_STYLE_SCROLLBAR_SLIDER 7  ///<,
#define  XC_BUTTON_STYLE_TABBAR_BUTTON    8  ///<TabBarϵİť

///@}


//ťͼ뷽ʽ
/// @defgroup groupIconAlign ťͼ뷽ʽ
/// @ingroup macroDefine
/// @{
#define XC_ICON_ALIGN_LEFT     0  ///<ͼ
#define XC_ICON_ALIGN_TOP      1  ///<ͼڶ
#define XC_ICON_ALIGN_RIGHT    2  ///<ͼұ
#define XC_ICON_ALIGN_BOTTOM   3  ///<ͼڵײ

///@}

/// @defgroup groupLayoutSize ִС
/// @ingroup macroDefine
/// @{
#define  XC_LAYOUT_SIZE_Size      0   ///<ָС
#define  XC_LAYOUT_SIZE_Fill      1   ///<fill 丸
#define  XC_LAYOUT_SIZE_Auto      2   ///<auto ԶС,ݼС
#define  XC_LAYOUT_SIZE_Weight    3   ///<weight ,ʣռ
#define  XC_LAYOUT_SIZE_Disable   4   ///<disable ʹ
///@}

/// @defgroup  groupListStyle  Listʽ
/// @ingroup macroDefine
/// @{
#define  XC_LIST_STYLE_DRAW_LEAVE   1  ///<뿪״̬
#define  XC_LIST_STYLE_DRAW_SELECT  2  ///<ѡ״̬
#define  XC_LIST_STYLE_DRAW_STAY    4  ///<ͣ״̬
/// @}

/// @defgroup  groupListBoxStyle  ListBoxʽ
/// @ingroup macroDefine
/// @{
#define  XC_LISTBOX_STYLE_DRAW_LEAVE   1  ///<뿪״̬
#define  XC_LISTBOX_STYLE_DRAW_SELECT  2  ///<ѡ״̬
#define  XC_LISTBOX_STYLE_DRAW_STAY    4  ///<ͣ״̬
/// @}

/// @defgroup  groupTreeStyle  Treeʽ
/// @ingroup macroDefine
/// @{
#define  XC_TREE_STYLE_DRAW_LEAVE   1  ///<뿪״̬
#define  XC_TREE_STYLE_DRAW_SELECT  2  ///<ѡ״̬
/// @}

//////////////ܴ///////////////////////////////////////////////
//˵
#define  IDM_LOCK          1000000006    ///<
#define  IDM_DOCK          1000000007    ///<ͣ
#define  IDM_FLOAT         1000000008    ///<
#define  IDM_HIDE          1000000009    ///<

enum pane_align_type_
{
	align_any=1,
	align_left,
	align_top,
	align_right,
	align_bottom,
	align_group_member, //Ա
};

enum  layout_align_
{
	layout_align_left=1,
	layout_align_top,
	layout_align_right,
	layout_align_bottom,
	layout_align_center,
	layout_align_equidistant,
};

//״̬
enum pane_state_
{
	pane_state_any=0,
	pane_state_lock,
	pane_state_dock,
	pane_state_float,
	pane_state_hide,
};


typedef void (CALLBACK *pFunDebugError)(const char *pInfo); //ص
/////////////////////////////////////////////////////////
//////////////ṹ/////////////////////////////////
/////////////////////////////////////////////////////////
struct BorderSize_  //4ߵĴС
{
	int  leftSize;
	int  topSize;
	int  rightSize;
	int  bottomSize;
};
typedef  BorderSize_  SpaceSize_ , PaddingSize_;

struct  template_info_i
{
	int    info;
};

struct listBox_item_i
{
	int     nUserData;  ///<û
	int     nHeight;    ///<Ĭϸ߶
	int     nSelHeight; ///<ѡʱ߶
	BOOL    bSelect;    ///<Ƿѡ
	int     index;      ///<
	RECT    rcItem;     ///<
	HXCGUI  hLayout;     ///<ֶ
	template_info_i  *pInfo;   ///<ģϢ
};

struct listBox_item_Info_i
{
	int     nUserData;  //û
	int     nHeight;
	int     nSelHeight;
};

struct list_item_i
{
	int     index;
	int     iSubItem;
	int     nUserData;
	BOOL    bSelect;
	RECT    rcItem;
	HXCGUI  hLayout;     ///<ֶ
	template_info_i  *pInfo;   ///<ģϢ
};

struct list_header_item_i
{
	int       nState;
	int       nUserData;
	BOOL      bSelect;
	RECT      rcItem;
};

struct tree_item_i
{
	int     nID;
	int     nDepth;
	int     nState;
	int     nHeight;
	int     nSelHeight;
	int     nUserData;
	BOOL    bSelect;
	BOOL    bExpand;
	RECT    rcItem;
	HXCGUI  hLayout;     ///<ֶ
	template_info_i  *pInfo;   ///<ģϢ
};

struct listView_item_i
{
	int     iGroup;    // -1û
	int     iItem;     //λ
	int     userData;  //û
	int     state;      
	BOOL    bSelect;
	RECT    rect; //,߿
	HXCGUI  hLayout;     ///<ֶ
	template_info_i  *pInfo;   ///<ģϢ
};

//Ϣ
struct layout_info_i
{
	int  width;    //
	int  height;   //߶
};

///////////////////////////////////////////////////////////////////////////////////
/////////////////////Ϣ//////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

//Ϣ
/**
@addtogroup wndMSG

<hr>
<h2>Windows ׼Ϣ</h2>
- @ref WM_PAINT ڻϢ
- @ref WM_CLOSE ڹرϢ.
- @ref WM_DESTROY Ϣ.
- @ref WM_NCDESTROY ڷǿͻϢ.
- @ref WM_MOUSEMOVE ƶϢ.
- @ref WM_LBUTTONDOWN Ϣ
- @ref WM_LBUTTONUP Ϣ.
- @ref WM_RBUTTONDOWN ҼϢ.
- @ref WM_RBUTTONUP ҼϢ.
- @ref WM_LBUTTONDBLCLK ˫Ϣ.
- @ref WM_RBUTTONDBLCLK Ҽ˫Ϣ.
- @ref WM_MOUSEWHEEL ֹϢ.
- @ref WM_EXITSIZEMOVE ˳ƶСģʽѭģμMSDN.
- @ref WM_MOUSEHOVER Ϣ
- @ref WM_MOUSELEAVE 뿪Ϣ.
- @ref WM_SIZE ڴСıϢ.
- @ref WM_TIMER ڶʱϢ.
- @ref WM_SETFOCUS ڻý.
- @ref WM_KILLFOCUS ʧȥ.
- @ref WM_KEYDOWN ڼ̰Ϣ.
- @ref WM_CAPTURECHANGED 겶ıϢ.
- @ref WM_SETCURSOR  .
- @ref WM_CHAR       ַϢ.
- @ref other WindowsϵͳϢ,ԶWindowsϢ.

<hr>
@anchor WM_PAINT WM_PAINT ڻϢ
@code   int CALLBACK OnWndDrawWindow(HDRAW hDraw,BOOL *pbHandled); @endcode
@param  hDraw   ͼλƾ.

<hr>
@anchor WM_CLOSE WM_CLOSE ڹرϢ.
@code   int CALLBACK OnWndClose(BOOL *pbHandled); @endcode

<hr>
@anchor WM_DESTROY WM_DESTROY Ϣ.
@code   int CALLBACK OnWndDestroy(BOOL *pbHandled);  @endcode

<hr>
@anchor WM_NCDESTROY WM_NCDESTROY ڷǿͻϢ.
@code   int CALLBACK OnWndNCDestroy(BOOL *pbHandled); @endcode

<hr>
@anchor WM_MOUSEMOVE WM_MOUSEMOVE ƶϢ.
@code   int CALLBACK OnWndMouseMove(UINT flags,POINT *pPt,BOOL *pbHandled);  @endcode
@param  flags   μMSDN WM_MOUSEMOVE wParam.
@param  pPt     .

<hr>
@anchor WM_LBUTTONDOWN WM_LBUTTONDOWN Ϣ
@code   int CALLBACK OnWndLButtonDown(UINT flags,POINT *pPt,BOOL *pbHandled); @endcode
@param  flags   μMSDN WM_LBUTTONDOWN.
@param  pPt     .

<hr>
@anchor WM_LBUTTONUP WM_LBUTTONUP Ϣ.
@code   int CALLBACK OnWndLButtonUp(UINT flags,POINT *pPt,BOOL *pbHandled); @endcode
@param  flags   μMSDN WM_LBUTTONUP.
@param  pPt     .

<hr>
@anchor WM_RBUTTONDOWN WM_RBUTTONDOWN ҼϢ.
@code   int CALLBACK OnWndRButtonDown(UINT flags,POINT *pPt,BOOL *pbHandled); @endcode
@param  flags   μMSDN WM_RBUTTONDOWN.
@param  pPt     .

<hr>
@anchor WM_RBUTTONUP WM_RBUTTONUP ҼϢ.
@code   int CALLBACK OnWndRButtonUp(UINT flags,POINT *pPt,BOOL *pbHandled); @endcode
@param  flags   μMSDN WM_RBUTTONUP.
@param  pPt     .

<hr>
@anchor WM_LBUTTONDBLCLK WM_LBUTTONDBLCLK ˫Ϣ.
@code   int CALLBACK OnWndLButtonDBClick(UINT flags,POINT *pPt,BOOL *pbHandled); @endcode
@param  flags   μMSDN WM_LBUTTONDBLCLK.
@param  pPt     .

<hr>
@anchor WM_RBUTTONDBLCLK WM_RBUTTONDBLCLK Ҽ˫Ϣ.
@code   int CALLBACK OnWndRButtonDBClick(UINT flags,POINT *pPt,BOOL *pbHandled); @endcode
@param  flags   μMSDN WM_RBUTTONDBLCLK.
@param  pPt     .

<hr>
@anchor WM_MOUSEWHEEL WM_MOUSEWHEEL ֹϢ.
@code   int CALLBACK OnWndMouseWheel(UINT flags,POINT *pPt,BOOL *pbHandled); @endcode
@param  flags   μMSDN WM_MOUSEWHEELϢwParam.
@param  pPt     .

<hr>
@anchor WM_EXITSIZEMOVE WM_EXITSIZEMOVE ˳ƶСģʽѭģμMSDN.
@code   int CALLBACK OnWndExitSizeMove(BOOL *pbHandled); @endcode

<hr>
@anchor WM_MOUSEHOVER WM_MOUSEHOVER Ϣ.
@code   int CALLBACK OnWndMouseHover(UINT flags,POINT *pPt,BOOL *pbHandled); @endcode
@param  flags  μMSDN WM_MOUSEHOVERϢwParam.
@param  pPt    λ

<hr>
@anchor WM_MOUSELEAVE WM_MOUSELEAVE 뿪Ϣ.
@code   int CALLBACK OnWndMouseLeave(BOOL *pbHandled); @endcode

<hr>
@anchor WM_SIZE WM_SIZE ڴСıϢ.
@code   int CALLBACK OnWndSize(UINT flags,SIZE *pSize,BOOL *pbHandled); @endcode
@param  flags   μMSDN WM_SIZEϢwParam.
@param  pSize   ڴС.

<hr>
@anchor WM_TIMER WM_TIMER ڶʱϢ.
@code   int CALLBACK OnWndTimer(UINT nIDEvent,BOOL *pbHandled); @endcode
@param  nIDEnent ʱʾ.
@param  uElapse  ָϵͳĺ,GetTickCountķֵ.

<hr>
@anchor WM_SETFOCUS WM_SETFOCUS ڻý.
@code   int CALLBACK OnWndSetFocus(BOOL *pbHandled); @endcode

<hr>
@anchor WM_KILLFOCUS WM_KILLFOCUS ʧȥ.
@code   int CALLBACK OnWndKillFocus(BOOL *pbHandled); @endcode

<hr>
@anchor WM_KEYDOWN WM_KEYDOWN ڼ̰Ϣ.
@code   int CALLBACK OnWndKeyDown(WPARAM wParam,LPARAM lParam,BOOL *pbHandled); @endcode
@note   wParam,lParam:μMSDN WM_KEYDOWN.

<hr>
@anchor WM_CAPTURECHANGED WM_CAPTURECHANGED 겶ıϢ.
@code   int CALLBACK OnWndCaptureChanged(HWND hWnd,BOOL *pbHandled); @endcode
@param  hWnd    겶Ĵھ.

<hr>
@anchor  WM_SETCURSOR WM_SETCURSOR .
@code    int CALLBACK OnWndSetCursor(WPARAM wParam,LPARAM lParam,BOOL *pbHandled); @endcode
@note    wParam,lParam:μMSDN WM_SETCURSOR.

<hr>
@anchor  WM_CHAR WM_CHAR ַϢ.
@code    int CALLBACK OnWndChar(WPARAM wParam,LPARAM lParam,BOOL *pbHandled); @endcode
@note    wParam,lParam:μMSDN WM_CHAR.

<hr>
@anchor other WindowsϵͳϢ,ԶWindowsϢ.
@code   int CALLBACK OnWndOther(WPARAM wParam,LPARAM lParam,BOOL *pbHandled); @endcode
@param  wParam  Ϣ.
@param  lParam  Ϣ.
@note   ϢμMSDN.
@{
*/

//wParam:left-top; lParam:right-bottom; 2Ϊ,ôػ
#define  XWM_REDRAW            WM_APP+1007  //ػʱ ---------ڲԶϢ

//Ϣ-ϵͳǿͻϢ
#define  XWM_EVENT_ALL        WM_APP+1000 //¼Ͷ --------------Ҫע

#define  XWM_WINDPROC         0x7000    //עᴰڴ
#define  XWM_DRAW_T           0x7000+9  //ڻ,ڲʹ, wParam:0, lParam:0

///@brief ˵ѡ
///@code  int CALLBACK OnWndMenuSelect(int nID,BOOL *pbHandled); @endcode
#define  XWM_MENUSELECT       0x7000+4 //˵ѡ wParam:˵ID, lParam:0

///@brief ˵˳
///@code  int CALLBACK OnWndMenuExit(BOOL *pbHandled); @endcode
#define  XWM_MENUEXIT         0x7000+5 //˵˳ wParam:0, lParam:0
///@}

///////////////////////////////////////////////////////////////////////////////////
/////////////////Ԫ¼//////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
//Ԫ¼
/// @addtogroup eleEvents
/// @{


/// @brief Ԫش¼.
/// @code  int CALLBACK OnEventProc(HELE hEventEle, UINT nEvent, WPARAM wParam, LPARAM lParam, BOOL *pbHandled) @endcode
#define  XE_ELEPROCE         1     ///Ԫ¼

/// @brief Ԫػ¼
/// @code  int CALLBACK OnDraw(HDRAW hDraw,BOOL *pbHandled);  @endcode
#define  XE_PAINT            2

/// @brief ԪؼԪػ¼.øùҪXEle_EnableEvent_XE_PAINT_END();
/// @code  int CALLBACK OnPaintEnd(HDRAW hDraw,BOOL *pbHandled); @endcode
#define  XE_PAINT_END        3     //ԪؼԪػɺ󴥷,Ҫøù,XEle_EnableEvent_XE_PAINT_END();

/// @brief ͼ¼.
/// @code int CALLBACK OnDrawScrollView(HDRAW hDraw,BOOL *pbHandled); @endcode
#define  XE_PAINT_SCROLLVIEW   4

/// @brief Ԫƶ¼.
/// @code  int CALLBACK OnMouseMove(UINT flags, POINT *pPt, BOOL *pbHandled);  @endcode
#define  XE_MOUSEMOVE        5

/// @brief Ԫ¼.
/// @code  int CALLBACK OnMouseStay(BOOL *pbHandled); @endcode
#define  XE_MOUSESTAY        6   ///ͣ

/// @brief Ԫͣ¼.
/// @code  int CALLBACK OnMouseHover(UINT flags, POINT *pPt, BOOL *pbHandled); @endcode
#define  XE_MOUSEHOVER       7   ///ͣ

/// @brief Ԫ뿪¼.
/// @code  int CALLBACK OnMouseLeave(BOOL *pbHandled); @endcode
#define  XE_MOUSELEAVE       8   ///뿪

/// @brief Ԫֹ¼.
/// @code  int CALLBACK OnMouseWheel(UINT flags,POINT *pPt,BOOL *pbHandled); @endcode
/// @param flags      MSDNWM_MOUSEWHEELϢwParam˵.
#define  XE_MOUSEWHEEL         9  //  wParam:ʶ,lParam:POINT

/// @brief ¼.
/// @code  int CALLBACK OnLButtonDown(UINT flags, POINT *pPt,BOOL *pbHandled);  @endcode
#define  XE_LBUTTONDOWN        10

/// @brief ¼.
/// @code  int CALLBACK OnLButtonUp(UINT flags, POINT *pPt,BOOL *pbHandled); @endcode
#define  XE_LBUTTONUP          11

/// @brief Ҽ¼.
/// @code  int CALLBACK OnRButtonDOWN(UINT flags, POINT *pPt,BOOL *pbHandled);  @endcode
#define  XE_RBUTTONDOWN        12

/// @brief Ҽ¼.
/// @code int CALLBACK OnRButtonUp(UINT flags, POINT *pPt,BOOL *pbHandled);  @endcode
#define  XE_RBUTTONUP          13

/// @brief ˫¼.
/// @code   int CALLBACK OnLButtonDBClick(UINT flags, POINT *pPt,BOOL *pbHandled); @endcode
#define  XE_LBUTTONDBCLICK     14

#define  XE_RBUTTONDBCLICK     15

/// @brief Ԫػý¼.
/// @code int CALLBACK OnSetFocus(BOOL *pbHandled); @endcode
#define  XE_SETFOCUS           31

/// @brief Ԫʧȥ¼.
/// @code int CALLBACK OnKillFocus(BOOL *pbHandled); @endcode
#define  XE_KILLFOCUS          32

/// @brief Ԫ¼.
/// @code int CALLBACK OnDestroy(BOOL *pbHandled); @endcode
#define  XE_DESTROY            33   //Ԫ

/// @brief ť¼.
/// @code int CALLBACK OnBtnClick(BOOL *pbHandled); @endcode
#define  XE_BNCLICK            34

/// @brief ťѡ¼.
/// @code int CALLBACK OnButtonCheck(BOOL bCheck,BOOL *pbHandled); @endcode
#define  XE_BUTTON_CHECK       35  //ťѡ¼

/// @brief ԪشСı¼.
/// @code int CALLBACK *OnSize(BOOL *pbHandled); @endcode
#define  XE_SIZE               36

/// @brief Ԫʾ¼.
/// @code  int CALLBACK OnShow(BOOL bShow,BOOL *pbHandled); @endcode
#define  XE_SHOW               37  //wParam:TRUEFALSE, lParam:0

/// @brief Ԫ¼.
/// @code  int CALLBACK OnSetFont(BOOL *pbHandled); @endcode
#define  XE_SETFONT           38

/// @brief Ԫذ¼.
/// @code  int CALLBACK OnEventKeyDown(WPARAM wParam,LPARAM lParam,BOOL *pbHandled); @endcode
/// @note  wParam,lParam:μMSDN WM_KEYDOWN. 
#define  XE_KEYDOWN            39 //wParamlParam׼Ϣͬ

/// @brief ͨTranslateMessageַ¼.
/// @code  int CALLBACK OnEventChar(WPARAM wParam,LPARAM lParam,BOOL *pbHandled); @endcode
/// @note   wParam,lParam:μMSDN WM_KEYDOWN. 
#define  XE_CHAR               40   //wParamlParamμMSDN

/// @brief Ԫ겶.
/// @code int CALLBACK OnSetCapture(BOOL *pbHandled); @endcode
#define  XE_SETCAPTURE      51

/// @brief Ԫʧȥ겶.
/// @code int CALLBACK OnKillCapture(BOOL *pbHandled); @endcode
#define  XE_KILLCAPTURE     52

/// @brief 
/// @code int CALLBACK OnSetCursor(WPARAM wParam,LPARAM lParam,BOOL *pbHandled) @endcode
#define  XE_SETCURSOR            53  // SetCursor

/// @brief ͼԪˮƽ¼,ͼ.
/// @code  int CALLBACK OnScrollViewScrollH(int pos,BOOL *pbHandled); @endcode
/// @param pos         ǰ.
#define  XE_SCROLLVIEW_SCROLL_H    54  //ͼ ¼ wParam:,lParam:0 (ͼ,ͼѹ)

/// @brief ͼԪشֱ¼,ͼ.
/// @code  int CALLBACK OnScrollViewScrollV(int pos,BOOL *pbHandled); @endcode
/// @param pos         ǰ.
#define  XE_SCROLLVIEW_SCROLL_V    55  //ͼ ¼ wParam:,lParam:0 (ͼ,ͼѹ)

/// @brief Ԫع¼,.
/// @code  int CALLBACK OnSBarScroll(int pos,BOOL *pbHandled); @endcode
/// @param pos   ǰ.
#define  XE_SBAR_SCROLL        56   //¼ wParam:,lParam:0 ()

/// @brief ˵ѡ¼.
/// @code  int CALLBACK OnEventMenuSelect(int nItem,BOOL *pbHandled); @endcode
/// @param id          ˵id.
#define  XE_MENUSELECT      57  //˵ѡ wParam:˵ID,lParam:0

/// @brief ˵˳¼.
/// @code  int CALLBACK OnMenuExit(BOOL *pbHandled); @endcode
#define  XE_MENUEXIT        58 //˵˳

/// @brief Ԫ,λøı¼.
/// @code  int CALLBACK OnSliderBarChange(int pos,BOOL *pbHandled); @endcode
#define  XE_SLIDERBAR_CHANGE   59

/// @brief Ԫ,ȸı¼.
/// @code  int CALLBACK OnProgressBarChange(int pos,BOOL *pbHandled); @endcode
#define  XE_PROGRESSBAR_CHANGE  60

/// @brief Ͽбѡ¼.
/// @code  int CALLBACK OnComboBoxSelect(int iItem,BOOL *pbHandled);  @endcode
#define  XE_COMBOBOX_SELECT       71   //Ͽѡ  

#define  XE_COMBOBOX_POPUP_LIST   72

#define  XE_COMBOBOX_EXIT_LIST    73

/// @brief бԪ,ģ崴.
/// @code int CALLBACK OnListBoxTemplateCreate(listBox_item_i* pItem,BOOL *pbHandled); @endcode
#define  XE_LISTBOX_TEMP_CREATE     81

/// @brief бԪ,ģ崴¼.
/// @code int CALLBACK OnListBoxTemplateCreateEnd(listBox_item_i* pItem,BOOL *pbHandled); @endcode
#define  XE_LISTBOX_TEMP_CREATE_END     82

/// @brief бԪ,ģ.
/// @code int CALLBACK OnListBoxTemplateDestroy(listBox_item_i* pItem,BOOL *pbHandled); @endcode
#define  XE_LISTBOX_TEMP_DESTROY    83

/// @brief бԪ,ģ.
/// @code  int CALLBACK OnListBoxTemplateAdjustCoordinate(listBox_item_i* pItem,BOOL *pbHandled); @endcode
#define  XE_LISTBOX_TEMP_ADJUST_COORDINATE  84

/// @brief бԪ,¼.
/// @code  int CALLBACK OnListBoxDrawItem(HDRAW hDraw,listBox_item_i* pItem,BOOL *pbHandled); @endcode
#define  XE_LISTBOX_DRAWITEM     85

/// @brief бԪ,ѡ¼.
/// @code  int CALLBACK OnListBoxSelect(int iItem,BOOL *pbHandled);  @endcode
#define  XE_LISTBOX_SELECT       86

/// @brief бԪ,ģ崴.
/// @code  int CALLBACK OnListTemplateCreate(list_item_i* pItem,BOOL *pbHandled); @endcode
#define  XE_LIST_TEMP_CREATE     101

/// @brief бԪ,ģ崴¼.
/// @code  int CALLBACK OnListTemplateCreateEnd(list_item_i* pItem,BOOL *pbHandled); @endcode
#define  XE_LIST_TEMP_CREATE_END     102

/// @brief бԪ,ģ.
/// @code int CALLBACK OnListTemplateDestroy(list_item_i* pItem,BOOL *pbHandled); @endcode
#define  XE_LIST_TEMP_DESTROY    103

/// @brief бԪ,ģ.
/// @code  typedef int CALLBACK OnListTemplateAdjustCoordinate(list_item_i* pItem,BOOL *pbHandled); @endcode
#define  XE_LIST_TEMP_ADJUST_COORDINATE  104

/// @brief бԪ,.
/// @code  int CALLBACK OnListDrawItem(HDRAW hDraw,list_item_i* pItem,BOOL *pbHandled); @endcode
#define  XE_LIST_DRAWITEM                105

/// @brief бԪ,ѡ¼.
/// @code  int CALLBACK OnListSelect(int iItem,BOOL *pbHandled); @endcode
#define  XE_LIST_SELECT                  106

/// @brief бԪػбͷ.
/// @code  int CALLBACK OnListHeaderDrawItem(HDRAW hDraw, list_header_item_i* pItem, BOOL *pbHandled); @endcode
#define  XE_LIST_HEADER_DRAWITEM         107

#define  XE_LIST_HEADER_CLICK            108

#define  XE_LIST_HEADER_WIDTH_CHANGE     109

/// @brief Ԫ,ģ崴.
/// @code  int CALLBACK OnTreeTemplateCreate(tree_item_i* pItem,BOOL *pbHandled); @endcode
#define  XE_TREE_TEMP_CREATE             121  

/// @brief Ԫ,ģ崴.
/// @code  int CALLBACK OnTreeTemplateCreateEnd(tree_item_i* pItem,BOOL *pbHandled); @endcode
#define  XE_TREE_TEMP_CREATE_END         122

/// @brief Ԫ,ģ.
/// @code  int CALLBACK OnTreeTemplateDestroy(tree_item_i* pItem,BOOL *pbHandled); @endcode
#define  XE_TREE_TEMP_DESTROY            123 

/// @brief Ԫ,ģ,.
/// @code  int CALLBACK OnTreeTemplateAdjustCoordinate(tree_item_i* pItem,BOOL *pbHandled); @endcode
#define  XE_TREE_TEMP_ADJUST_COORDINATE  124  

/// @brief Ԫ,.
/// @code  int CALLBACK OnTreeDrawItem(HDRAW hDraw,tree_item_i* pItem,BOOL *pbHandled); @endcode
#define  XE_TREE_DRAWITEM                125  

/// @brief Ԫ,ѡ¼.
/// @code  int CALLBACK OnTreeSelect(int nItemID,BOOL *pbHandled); @endcode
/// @param nItemID  ID.
#define  XE_TREE_SELECT                 126

/// @brief Ԫ,չ¼.
/// @code int CALLBACK OnTreeExpand(int id,BOOL bExpand,BOOL *pbHandled); @endcode
#define  XE_TREE_EXPAND                 127

/// @brief бԪ,ģ崴.
/// @code  int CALLBACK OnListViewTemplateCreate(listView_item_i* pItem,BOOL *pbHandled); @endcode
#define  XE_LISTVIEW_TEMP_CREATE           141

/// @brief бԪ,ģ崴¼.
/// @code  int CALLBACK OnListViewTemplateCreateEnd(listView_item_i* pItem,BOOL *pbHandled); @endcode
#define  XE_LISTVIEW_TEMP_CREATE_END           142

/// @brief бԪ,ģ.
/// @code  int CALLBACK OnListViewTemplateDestroy(listView_item_i* pItem,BOOL *pbHandled); @endcode
#define  XE_LISTVIEW_TEMP_DESTROY           143

/// @brief бԪ,ģ.
/// @code  int CALLBACK OnListViewTemplateAdjustCoordinate(listView_item_i* pItem,BOOL *pbHandled); @endcode
#define  XE_LISTVIEW_TEMP_ADJUST_COORDINATE   144

/// @brief бԪ,Ի.
/// @code int CALLBACK OnListViewDrawItem(HDRAW hDraw,listView_item_i* pItem,BOOL *pbHandled);  @endcode
#define  XE_LISTVIEW_DRAWITEM              145

/// @brief бԪ,ѡ¼.
/// @code int CALLBACK OnListViewSelect(int iGroup,int iItem,BOOL *pbHandled); @endcode
#define  XE_LISTVIEW_SELECT            146

/// @brief бԪ,չ¼.
/// @code int CALLBACK OnListViewExpand(int iGroup,BOOL bExpand,BOOL *pbHandled); @endcode
#define  XE_LISTVIEW_EXPAND         147


/// @brief Ԫ ֵı¼
/// @code   int CALLBACK OnPGridValueChange(int nItemID,BOOL *pbHandled); @endcode
/// @param  nItemID  ID.
#define  XE_PGRID_VALUE_CHANGE     161

/// @brief ıԪ ݸı¼,ҪЧ,XRichEdit_EnableEvent_XE_RICHEDIT_CHANGE()
/// @code   int CALLBACK OnRichEditChange(BOOL *pbHandled); @endcode
#define  XE_RICHEDIT_CHANGE        162


//int CALLBACK OnRichEditSet(BOOL *pbHandled);
#define XE_RICHEDIT_SET     201

//int CALLBACK OnPGridItemSet(int nItemID, BOOL *pbHandled);
#define XE_PGRID_ITEM_SET   202

/// @brief  TabBarǩťѡı¼
/// @code   int CALLBACK OnTabBarSelect(int iItem, BOOL *pbHandled); @endcode
/// @param  iItem  ǩλ.
#define  XE_TABBAR_SELECT    221

/// @brief  TabBarǩťɾ¼
/// @code   int CALLBACK OnTabBarDelete(int iItem, BOOL *pbHandled); @endcode
/// @param  iItem  ǩλ.
#define  XE_TABBAR_DELETE    222

#define  XE_LISTVIEW_DRAG_INSERT
#define  XE_MONTHCAL_CHANGE
#define  XE_DATETIME_CHANGE
#define  XE_DATETIME_POPUP_MONTHCAL
#define  XE_DATETIME_EXIT_MONTHCAL
#define  XE_PANE_LOACK
#define  XE_PANE_DOCK
#define  XE_PANE_FLOAT
#define  XE_EDIT_CHANGE

///@}

///////////////////////////////////////////////////////////////////////////////////
/////////////¼ע//////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
//#define  XC_EVENT_ERROR    char temp[256] ={ 0 };\
//	sprintf_s(temp, "error:Ҫ¼%s,Line=%d \n",__FUNCTION__, __LINE__); \
//	OutputDebugStringA(temp); return FALSE; 

#define XC_PARAM_int            1
#define XC_PARAM_uint           2
#define XC_PARAM_BOOL           3
#define XC_PARAM_CHAR           4
#define XC_PARAM_BYTE           5
#define XC_PARAM_HXCGUI         6
#define XC_PARAM_HWINDOW        7
#define XC_PARAM_HELE           8
#define XC_PARAM_HIMAGE         9
#define XC_PARAM_HDRAW          10
#define XC_PARAM_P_RECT         11
#define XC_PARAM_P_POINT        12
#define XC_PARAM_P_SIZE         13
#define XC_PARAM_P_BOOL         14
#define XC_PARAM_P_listBox_item_i      15
#define XC_PARAM_P_list_header_item_i  16
#define XC_PARAM_P_list_item_i         17
#define XC_PARAM_P_listView_item_i     18
#define XC_PARAM_P_tree_item_i         19


#define XC_FUN_int_w_uint_uint_uint_bPtr  1
typedef int(CALLBACK *pFun_int_w_uint_uint_uint_bPtr)(HWINDOW, UINT, WPARAM, LPARAM, BOOL*); //

#define XC_FUN_int_w_uint_ptPtr_bPtr  2
typedef int(CALLBACK *pFun_int_w_uint_ptPtr_bPtr)(HWINDOW, UINT, POINT*, BOOL*);

#define XC_FUN_int_w_hDraw_bPtr  3
typedef int(CALLBACK *pFun_int_w_hDraw_bPtr)(HWINDOW, HDRAW, BOOL*);

#define XC_FUN_int_uint_uint_uint_bPtr
typedef int(CALLBACK *pFun_int_uint_uint_uint_bPtr)(UINT, WPARAM, LPARAM, BOOL*);

#define XC_FUN_int_uint_ptPtr_bPtr
typedef int(CALLBACK *pFun_int_uint_ptPtr_bPtr)(UINT, POINT*, BOOL*);

#define XC_FUN_int_bPtr
typedef int(CALLBACK *pFun_int_bPtr)(BOOL*);

#define XC_FUN_int_uint_sizePtr_bPtr
typedef int(CALLBACK *pFun_int_uint_sizePtr_bPtr)(UINT,SIZE*,BOOL*);

//Ԫ
#define XC_FUN_int_uint_uint_bPtr
typedef int(CALLBACK *pFun_int_uint_uint_bPtr)(WPARAM, LPARAM, BOOL*); //Ԫ

#define XC_FUN_int_hDraw_bPtr
typedef int(CALLBACK *pFun_int_hDraw_bPtr)(HDRAW, BOOL*);

#define XC_FUN_int_uint_bPtr
typedef int(CALLBACK *pFun_int_uint_bPtr)(UINT, BOOL*);

#define XC_FUN_int_int_int_bPtr
typedef int(CALLBACK *pFun_int_int_int_bPtr)(int, int, BOOL*);

#define XC_FUN_int_int_bPtr
typedef int(CALLBACK *pFun_int_int_bPtr)(int, BOOL*);

#define XC_FUN_int_pListBoxItem_bPtr
typedef int(CALLBACK *pFun_int_pListBoxItem_bPtr)(listBox_item_i*, BOOL*);

#define XC_FUN_int_hDraw_pListBoxItem_bPtr
typedef int(CALLBACK *pFun_int_hDraw_pListBoxItem_bPtr)(HDRAW, listBox_item_i*, BOOL*);

#define XC_FUN_int_pListItem_bPtr
typedef int(CALLBACK *pFun_int_pListItem_bPtr)(list_item_i*, BOOL*);

#define XC_FUN_int_hDraw_pListItem_bPtr
typedef int(CALLBACK *pFun_int_hDraw_pListItem_bPtr)(HDRAW,list_item_i*, BOOL*);

#define XC_FUN_int_hDraw_pListHeaderItem_bPtr
typedef int(CALLBACK *pFun_int_hDraw_pListHeaderItem_bPtr)(HDRAW,list_header_item_i*, BOOL*);

#define XC_FUN_int_pTreeItem_bPtr
typedef int(CALLBACK *pFun_int_pTreeItem_bPtr)(tree_item_i*, BOOL*);

#define XC_FUN_int_hDraw_pTreeItem_bPtr
typedef int(CALLBACK *pFun_int_hDraw_pTreeItem_bPtr)(HDRAW,tree_item_i*, BOOL*);

#define XC_FUN_int_pListViewItem_bPtr
typedef int(CALLBACK *pFun_int_pListViewItem_bPtr)(listView_item_i*, BOOL*);

#define XC_FUN_int_hDraw_pListViewItem_bPtr
typedef int(CALLBACK *pFun_int_hDraw_pListViewItem_bPtr)(HDRAW,listView_item_i*, BOOL*);

//1
#define XC_FUN_int_e_uint_uint_uint_bPtr
typedef int(CALLBACK *pFun_int_e_uint_uint_uint_bPtr)(HELE, UINT, WPARAM, LPARAM, BOOL*); //Ԫ

#define XC_FUN_int_e_hDraw_bPtr
typedef int(CALLBACK *pFun_int_e_hDraw_bPtr)(HELE, HDRAW, BOOL*);

#define XC_FUN_int_e_bPtr
typedef int(CALLBACK *pFun_int_e_bPtr)(HELE, BOOL*);

//2
#define XC_FUN_int_e_e_uint_uint_uint_bPtr
typedef int(CALLBACK *pFun_int_e_e_uint_uint_uint_bPtr)(HELE, HELE, UINT, WPARAM, LPARAM, BOOL*); //Ԫ

#define XC_FUN_int_e_e_hDraw_bPtr
typedef int(CALLBACK *pFun_int_e_e_hDraw_bPtr)(HELE, HELE, HDRAW, BOOL*);


class CEventBase
{
public:
	CEventBase(){ m_nEvent=XC_ERROR; m_pFunCStyle=NULL; m_nParamNum=0; }
	UINT     m_nEvent;      //¼
	int      m_nParamNum;   //
	void*    m_pFunCStyle;
	virtual  int OnWndProc(HWINDOW hWindow, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT message = 0){ return 0; }
	virtual  int OnEleProc(HELE hEle, HELE hEventEle, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT nEvent = 0){ return 0; }
	virtual  void Release(){ delete this; }
	virtual  void* GetThis(){ return NULL; }
	virtual  char* GetFunName(){ return NULL; }
};


template<typename T_ClassName>
class CEventType
{
public:
	//
	typedef int(T_ClassName::*pFun_int_w_uint_uint_uint_bPtr)(HWINDOW, UINT, WPARAM, LPARAM, BOOL*); //
	typedef int(T_ClassName::*pFun_int_w_uint_ptPtr_bPtr)(HWINDOW, UINT, POINT*, BOOL*);
	typedef int(T_ClassName::*pFun_int_w_hDraw_bPtr)(HWINDOW, HDRAW, BOOL*);

	typedef int(T_ClassName::*pFun_int_uint_uint_uint_bPtr)(UINT, WPARAM, LPARAM, BOOL*); //
	typedef int(T_ClassName::*pFun_int_uint_ptPtr_bPtr)(UINT, POINT*, BOOL*);
	typedef int(T_ClassName::*pFun_int_bPtr)(BOOL*);
	typedef int(T_ClassName::*pFun_int_uint_sizePtr_bPtr)(UINT,SIZE*,BOOL*);

	//Ԫ
	typedef int(T_ClassName::*pFun_int_uint_uint_bPtr)(WPARAM, LPARAM, BOOL*); //Ԫ
	typedef int(T_ClassName::*pFun_int_hDraw_bPtr)(HDRAW, BOOL*);
	typedef int(T_ClassName::*pFun_int_uint_bPtr)(UINT, BOOL*);

	typedef int(T_ClassName::*pFun_int_pListBoxItem_bPtr)(listBox_item_i*, BOOL*);
	typedef int(T_ClassName::*pFun_int_hDraw_pListBoxItem_bPtr)(HDRAW, listBox_item_i*, BOOL*);

	typedef int(T_ClassName::*pFun_int_pListItem_bPtr)(list_item_i*, BOOL*);
	typedef int(T_ClassName::*pFun_int_hDraw_pListItem_bPtr)(HDRAW,list_item_i*, BOOL*);

	typedef int(T_ClassName::*pFun_int_hDraw_pListHeaderItem_bPtr)(HDRAW,list_header_item_i*, BOOL*);

	typedef int(T_ClassName::*pFun_int_pTreeItem_bPtr)(tree_item_i*, BOOL*);
	typedef int(T_ClassName::*pFun_int_hDraw_pTreeItem_bPtr)(HDRAW,tree_item_i*, BOOL*);

	typedef int(T_ClassName::*pFun_int_pListViewItem_bPtr)(listView_item_i*, BOOL*);
	typedef int(T_ClassName::*pFun_int_hDraw_pListViewItem_bPtr)(HDRAW,listView_item_i*, BOOL*);

	typedef int(T_ClassName::*pFun_int_int_int_bPtr)(int, int, BOOL*);
	typedef int(T_ClassName::*pFun_int_int_bPtr)(int, BOOL*);

	//1
	typedef int(T_ClassName::*pFun_int_e_uint_uint_uint_bPtr)(HELE, UINT, WPARAM, LPARAM, BOOL*); //Ԫ
	typedef int(T_ClassName::*pFun_int_e_hDraw_bPtr)(HELE, HDRAW, BOOL*);
	typedef int(T_ClassName::*pFun_int_e_bPtr)(HELE, BOOL*);
	typedef int(T_ClassName::*pFun_int_e_int_bPtr)(HELE, int, BOOL*);

	//2
	typedef int(T_ClassName::*pFun_int_e_e_uint_uint_uint_bPtr)(HELE, HELE, UINT, WPARAM, LPARAM, BOOL*); //Ԫ
	typedef int(T_ClassName::*pFun_int_e_e_hDraw_bPtr)(HELE, HELE, HDRAW, BOOL*);
};



template<typename T_ClassName>
class CEventHandleWnd : public CEventType < T_ClassName > //¼¼Զƥ
{
public:
	//HWINDOW
	BOOL  Handle(HWINDOW hWindow, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT message, T_ClassName* pThis, pFun_int_w_hDraw_bPtr pMember){
		return (pThis->*pMember)(hWindow, (HDRAW)wParam, (RECT*)lParam, pbHandled);
	}
	BOOL  Handle(HWINDOW hWindow, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT message, T_ClassName* pThis, pFun_int_uint_uint_uint_bPtr pMember){
		return (pThis->*pMember)(message, wParam, lParam, pbHandled);
	}
	BOOL  Handle(HWINDOW hWindow, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT message, T_ClassName* pThis, pFun_int_uint_ptPtr_bPtr pMember){
		return (pThis->*pMember)(wParam, (POINT*)lParam, pbHandled);
	}
	BOOL  Handle(HWINDOW hWindow, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT message, T_ClassName* pThis, pFun_int_hDraw_bPtr pMember){
		return (pThis->*pMember)((HDRAW)wParam, pbHandled);
	}
	BOOL  Handle(HWINDOW hWindow, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT message, T_ClassName* pThis, pFun_int_bPtr pMember){
		return (pThis->*pMember)(pbHandled);
	}
	BOOL  Handle(HWINDOW hWindow, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT message, T_ClassName* pThis, pFun_int_uint_sizePtr_bPtr pMember){
		return (pThis->*pMember)(wParam,(SIZE*)lParam,pbHandled);
	}
	BOOL  Handle(HWINDOW hWindow, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT message, T_ClassName* pThis, pFun_int_uint_uint_bPtr pMember){
		return (pThis->*pMember)(wParam, lParam, pbHandled);
	}
	BOOL  Handle(HWINDOW hWindow, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT message, T_ClassName* pThis, pFun_int_uint_bPtr pMember){
		return (pThis->*pMember)(wParam, pbHandled);
	}
	BOOL  Handle(HWINDOW hWindow, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT message, T_ClassName* pThis, pFun_int_int_bPtr pMember){
		return (pThis->*pMember)((int)wParam, pbHandled);
	}
};

template<typename T_ClassName>
class CEventHandleEle : public CEventType < T_ClassName > //¼¼Զƥ
{
public:
	//HELE
	BOOL  Handle(HELE hEle, HELE hEventEle, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT nEvent, T_ClassName* pThis, pFun_int_hDraw_bPtr pMember){
		return (pThis->*pMember)((HDRAW)wParam, pbHandled);
	}
	BOOL  Handle(HELE hEle, HELE hEventEle, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT nEvent, T_ClassName* pThis, pFun_int_e_uint_uint_uint_bPtr pMember){
		return (pThis->*pMember)(hEventEle, nEvent, wParam, lParam, pbHandled);
	}
	BOOL  Handle(HELE hEle, HELE hEventEle, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT nEvent, T_ClassName* pThis, pFun_int_bPtr pMember){
		return (pThis->*pMember)(pbHandled);
	}
	BOOL  Handle(HELE hEle, HELE hEventEle, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT nEvent, T_ClassName* pThis, pFun_int_uint_ptPtr_bPtr pMember){
		return (pThis->*pMember)(wParam, (POINT*)lParam, pbHandled);
	}
	BOOL  Handle(HELE hEle, HELE hEventEle, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT nEvent, T_ClassName* pThis, pFun_int_int_int_bPtr pMember){
		return (pThis->*pMember)((int)wParam, (int)lParam, pbHandled);
	}
	BOOL  Handle(HELE hEle, HELE hEventEle, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT nEvent, T_ClassName* pThis, pFun_int_int_bPtr pMember){
		return (pThis->*pMember)((int)wParam, pbHandled);
	}
	BOOL  Handle(HELE hEle, HELE hEventEle, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT nEvent, T_ClassName* pThis, pFun_int_uint_bPtr pMember){
		return (pThis->*pMember)(wParam, pbHandled);
	}
	BOOL  Handle(HELE hEle, HELE hEventEle, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT nEvent, T_ClassName* pThis, pFun_int_uint_uint_bPtr pMember){
		return (pThis->*pMember)(wParam, lParam, pbHandled);
	}
	BOOL  Handle(HELE hEle, HELE hEventEle, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT nEvent, T_ClassName* pThis, pFun_int_pListBoxItem_bPtr pMember){
		return (pThis->*pMember)((listBox_item_i*)wParam, pbHandled);
	}
	BOOL  Handle(HELE hEle, HELE hEventEle, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT nEvent, T_ClassName* pThis, pFun_int_hDraw_pListBoxItem_bPtr pMember){
		return (pThis->*pMember)((HDRAW)wParam,(listBox_item_i*)lParam, pbHandled);
	}
	BOOL  Handle(HELE hEle, HELE hEventEle, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT nEvent, T_ClassName* pThis, pFun_int_pListItem_bPtr pMember){
		return (pThis->*pMember)((list_item_i*)wParam, pbHandled);
	}
	BOOL  Handle(HELE hEle, HELE hEventEle, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT nEvent, T_ClassName* pThis, pFun_int_hDraw_pListItem_bPtr pMember){
		return (pThis->*pMember)((HDRAW)wParam,(list_item_i*)lParam, pbHandled);
	}
	BOOL  Handle(HELE hEle, HELE hEventEle, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT nEvent, T_ClassName* pThis, pFun_int_hDraw_pListHeaderItem_bPtr pMember){
		return (pThis->*pMember)((HDRAW)wParam,(list_header_item_i*)lParam, pbHandled);
	}
	BOOL  Handle(HELE hEle, HELE hEventEle, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT nEvent, T_ClassName* pThis, pFun_int_pTreeItem_bPtr pMember){
		return (pThis->*pMember)((tree_item_i*)wParam, pbHandled);
	}
	BOOL  Handle(HELE hEle, HELE hEventEle, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT nEvent, T_ClassName* pThis, pFun_int_hDraw_pTreeItem_bPtr pMember){
		return (pThis->*pMember)((HDRAW)wParam,(tree_item_i*)lParam, pbHandled);
	}

	BOOL  Handle(HELE hEle, HELE hEventEle, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT nEvent, T_ClassName* pThis, pFun_int_pListViewItem_bPtr pMember){
		return (pThis->*pMember)((listView_item_i*)wParam, pbHandled);
	}
	BOOL  Handle(HELE hEle, HELE hEventEle, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT nEvent, T_ClassName* pThis, pFun_int_hDraw_pListViewItem_bPtr pMember){
		return (pThis->*pMember)((HDRAW)wParam,(listView_item_i*)lParam, pbHandled);
	}
	///////////1/////////////////////
	BOOL  Handle(HELE hEle, HELE hEventEle, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT nEvent, T_ClassName* pThis, pFun_int_e_bPtr pMember){
		return (pThis->*pMember)(hEventEle, pbHandled);
	}
	BOOL  Handle(HELE hEle, HELE hEventEle, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT nEvent, T_ClassName* pThis, pFun_int_e_int_bPtr pMember){
		return (pThis->*pMember)(hEventEle, wParam, pbHandled);
	}
	BOOL  Handle(HELE hEle, HELE hEventEle, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT nEvent, T_ClassName* pThis, pFun_int_e_hDraw_bPtr pMember){
		return (pThis->*pMember)(hEventEle, (HDRAW)wParam, pbHandled);
	}
};

//ʡ1֤
template<typename T_ClassName>
class CEventWndTest : public  CEventType < T_ClassName >
{
public:
	void  Test(UINT nEvent, pFun_int_uint_uint_uint_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_uint;
		pArray[1]=XC_PARAM_uint;
		pArray[2]=XC_PARAM_uint;
	}
	void  Test(UINT nEvent, pFun_int_uint_ptPtr_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_uint;
		pArray[1]=XC_PARAM_P_POINT;
	}
	void  Test(UINT nEvent, pFun_int_hDraw_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_HDRAW;
	}
	void  Test(UINT nEvent, pFun_int_bPtr,BYTE* pArray){
	}
	void  Test(UINT nEvent, pFun_int_uint_sizePtr_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_uint;
		pArray[1]=XC_PARAM_P_SIZE;
	}
	void  Test(UINT nEvent, pFun_int_uint_uint_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_uint;
		pArray[1]=XC_PARAM_uint;
	}
	void  Test(UINT nEvent, pFun_int_uint_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_uint;
	}
	void  Test(UINT nEvent, pFun_int_int_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_int;
	}
};

template<typename T_ClassName>
class CEventWndTest2 : public  CEventType < T_ClassName >
{
public:
	void  Test(UINT nEvent, pFun_int_w_hDraw_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_HDRAW;
	}
};

//ȫ֤
template<typename T_ClassName>
class CEventEleTest3 : public  CEventType < T_ClassName >
{
public:
	void  Test(UINT nEvent, pFun_int_e_e_uint_uint_uint_bPtr){
		pArray[0]=XC_PARAM_uint;
		pArray[1]=XC_PARAM_uint;
		pArray[2]=XC_PARAM_uint;
	}
};

//ʡ1֤
template<typename T_ClassName>
class CEventEleTest2 : public  CEventType < T_ClassName >
{
public:
	void  Test(UINT nEvent, pFun_int_e_uint_uint_uint_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_uint;
		pArray[1]=XC_PARAM_uint;
		pArray[2]=XC_PARAM_uint;
	}
	void  Test(UINT nEvent, pFun_int_e_bPtr,BYTE* pArray){
	}
	void  Test(UINT nEvent, pFun_int_e_int_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_int;
	}
	void  Test(UINT nEvent, pFun_int_e_hDraw_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_HDRAW;
	}
};


//ʡ2֤
template<typename T_ClassName>
class CEventEleTest : public  CEventType < T_ClassName >
{
public:
	void  Test(UINT nEvent, pFun_int_hDraw_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_HDRAW;
	}
	void  Test(UINT nEvent, pFun_int_bPtr,BYTE* pArray){
	}
	void  Test(UINT nEvent, pFun_int_uint_ptPtr_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_uint;
		pArray[1]=XC_PARAM_P_POINT;
	}
	void  Test(UINT nEvent, pFun_int_int_int_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_int;
		pArray[1]=XC_PARAM_int;
	}
	void  Test(UINT nEvent, pFun_int_int_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_int;
	}
	void  Test(UINT nEvent, pFun_int_uint_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_uint;
	}
	void  Test(UINT nEvent, pFun_int_uint_uint_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_uint;
		pArray[1]=XC_PARAM_uint;
	}
	void  Test(UINT nEvent, pFun_int_pListBoxItem_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_P_listBox_item_i;
	}
	void  Test(UINT nEvent, pFun_int_hDraw_pListBoxItem_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_HDRAW;
		pArray[1]=XC_PARAM_P_listBox_item_i;
	}
	void  Test(UINT nEvent, pFun_int_pListItem_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_P_list_item_i;
	}
	void  Test(UINT nEvent, pFun_int_hDraw_pListItem_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_HDRAW;
		pArray[1]=XC_PARAM_P_list_item_i;
	}
	void  Test(UINT nEvent, pFun_int_hDraw_pListHeaderItem_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_HDRAW;
		pArray[1]=XC_PARAM_P_list_header_item_i;
	}

	void  Test(UINT nEvent,pFun_int_pTreeItem_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_P_tree_item_i;
	}
	void  Test(UINT nEvent,pFun_int_hDraw_pTreeItem_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_HDRAW;
		pArray[1]=XC_PARAM_P_tree_item_i;
	}

	void  Test(UINT nEvent,pFun_int_pListViewItem_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_P_listView_item_i;
	}
	void  Test(UINT nEvent,pFun_int_hDraw_pListViewItem_bPtr,BYTE* pArray){
		pArray[0]=XC_PARAM_HDRAW;
		pArray[1]=XC_PARAM_P_listView_item_i;
	}
};

template<typename T_ClassName, typename T_Member>
class CEventWnd : public  CEventBase
{
public:
	CEventWnd(){
		m_nEvent = 0; m_pThis = NULL; m_pMember = NULL; m_name[0]=NULL;
	}
	BOOL  Bind(char* pName,int nEvent, T_ClassName*  pThis, T_Member pMember){
		CEventWndTest<T_ClassName> EventTest;  //¼ʽ֤
		BYTE array[4]={0};
		EventTest.Test(nEvent, pMember,array);
		if(FALSE==XWnd_RegEventTest(nEvent,array))  return FALSE;

		m_nEvent = nEvent;  m_pThis = pThis;  m_pMember = pMember;
		strcpy_s(m_name,pName);
		return TRUE;
	}
	BOOL  Bind2(char* pName,int nEvent, T_ClassName*  pThis, T_Member pMember){
		CEventWndTest2<T_ClassName> EventTest;  //¼ʽ֤
		BYTE array[4]={0};
		EventTest.Test(nEvent, pMember,array);
		if(FALSE==XWnd_RegEventTest(nEvent,array))  return FALSE;

		m_nEvent = nEvent;  m_pThis = pThis;  m_pMember = pMember;
		strcpy_s(m_name,pName);
		return TRUE;
	}
	BOOL Remove(char* pName,HWINDOW hWindow, int nEvent, T_ClassName*  pThis, T_Member pMember){
		m_nEvent = nEvent;  m_pThis = pThis;  m_pMember = pMember;
		strcpy_s(m_name,pName);
		return XWnd_RemoveEventEx(hWindow,this);
	}
private:
	T_ClassName*   m_pThis;
	T_Member  m_pMember;
	char      m_name[MAX_PATH];
private:
	CEventHandleWnd<T_ClassName>   m_EventHandle;
	virtual void Release(){ delete this; }
	virtual int OnWndProc(HWINDOW hWindow, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT message){
		return m_EventHandle.Handle(hWindow, wParam, lParam, pbHandled, message, m_pThis, m_pMember);
	}
	virtual  void* GetThis(){ return m_pThis; }
	virtual  char* GetFunName(){ return m_name; }
};

template<typename T_ClassName, typename T_Member>
class CEventEle : public  CEventBase
{
public:
	CEventEle(){
		m_nEvent = 0; m_pThis = NULL; m_pMember = NULL;
		m_name[0]=0;
	}
	BOOL  Bind(char* pName,int nEvent, T_ClassName*  pThis, T_Member pMember){
		CEventEleTest<T_ClassName> EventTest;  //¼ʽ֤
		BYTE array[4]={0};
		EventTest.Test(nEvent, pMember,array);
		if(FALSE==XEle_RegEventTest(nEvent,array))  return FALSE;

		m_nEvent = nEvent;  m_pThis = pThis;  m_pMember = pMember;
		strcpy_s(m_name,pName);
		return TRUE;
	}
	BOOL  Bind2(char* pName,int nEvent, T_ClassName*  pThis, T_Member pMember){
		CEventEleTest2<T_ClassName> EventTest;  //¼ʽ֤
		BYTE array[4]={0};
		EventTest.Test(nEvent, pMember,array);
		if(FALSE==XEle_RegEventTest(nEvent,array))  return FALSE;

		m_nEvent = nEvent;  m_pThis = pThis;  m_pMember = pMember;
		strcpy_s(m_name,pName);
		return TRUE;
	}
	BOOL  Bind3(char* pName,int nEvent, T_ClassName*  pThis, T_Member pMember){
		CEventEleTest3<T_ClassName> EventTest;  //¼ʽ֤
		BYTE array[4]={0};
		EventTest.Test(nEvent, pMember,array);
		if(FALSE==XEle_RegEventTest(nEvent,array))  return FALSE;

		m_nEvent = nEvent;  m_pThis = pThis;  m_pMember = pMember;
		strcpy_s(m_name,pName);
		return TRUE;
	}
	BOOL Remove(char* pName,HELE hEle, int nEvent, T_ClassName*  pThis, T_Member pMember)
	{
		m_nEvent = nEvent;  m_pThis = pThis;  m_pMember = pMember;
		strcpy_s(m_name,pName);
		return XEle_RemoveEventEx(hEle,this);
	}
private:
	T_ClassName*   m_pThis;
	T_Member  m_pMember;
	char  m_name[MAX_PATH];

	CEventHandleEle<T_ClassName>   m_EventHandle;
	virtual void Release(){ delete this; }
	virtual int OnEleProc(HELE hEle, HELE hEventEle, WPARAM wParam, LPARAM lParam, BOOL *pbHandled, UINT nEvent){
		return m_EventHandle.Handle(hEle, hEventEle, wParam, lParam, pbHandled, nEvent, m_pThis, m_pMember);
	}
	virtual  void* GetThis(){ return m_pThis; }
	virtual  char* GetFunName(){ return m_name; }
};

///////////////////////////////////////////////////////////////
template<typename T_ClassName, typename T_Member>
void _XWnd_RegEventCPP1(HWINDOW hWindow, int nEvent, T_ClassName *pThis, T_Member pFun, wchar_t* pFunName, char* pFile, int pLine)
{
	CEventWnd< T_ClassName, T_Member > *pEvent = new CEventWnd < T_ClassName, T_Member > ;
	if (pEvent->Bind2(pFunName,nEvent, pThis, pFun)){
		XWnd_RegEventEx(hWindow, pEvent);  return;
	}	delete pEvent;
}

// עᴰ¼,ԱΪ¼ص.صʡԲ.
#define XWnd_RegEventCPP1(hWindow, nEvent,pFunMember)  _XWnd_RegEventCPP1(hWindow, nEvent, this, pFunMember,#pFunMember,__FILE__,__LINE__);

template<typename T_ClassName, typename T_Member>
void _XWnd_RegEventCPP(HWINDOW hWindow, int nEvent, T_ClassName *pThis, T_Member pFun, char* pFunName, char* pFile, int pLine)
{
	CEventWnd< T_ClassName, T_Member > *pEvent = new CEventWnd < T_ClassName, T_Member > ;
	if (pEvent->Bind(pFunName,nEvent, pThis, pFun)){
		XWnd_RegEventEx(hWindow, pEvent);  return;
	}	delete pEvent;
}

// עᴰ¼,ԱΪ¼ص.صʡԲhWindow.
#define XWnd_RegEventCPP(hWindow, nEvent,pFunMember)  _XWnd_RegEventCPP(hWindow, nEvent, this, pFunMember,#pFunMember,__FILE__,__LINE__);

template<typename T_ClassName, typename T_Member>
BOOL _Wnd_RemoveEventCPP(HWINDOW hWindow, int nEvent, T_ClassName *pThis, T_Member pFun,char* pFunName)
{
	CEventWnd< T_ClassName, T_Member > Event;
	return Event.Remove(pFunName,hWindow,nEvent, pThis, pFun);
}
//Ƴ¼C++
#define XWnd_RemoveEventCPP(hWindow,nEvent,pFunMember)  _Wnd_RemoveEventCPP(hWindow,nEvent,this,pFunMember,#pFunMember)


////////////////Ԫ///////////////////////////////////////////////////
template<typename T_ClassName, typename T_Member>
void _XEle_RegEventCPP2(HELE hEle, int nEvent, T_ClassName *pThis, T_Member pFun,char* pFunName)
{
	CEventEle< T_ClassName, T_Member > *pEvent = new CEventEle < T_ClassName, T_Member > ;
	if (pEvent->Bind3(pFunName,nEvent, pThis, pFun)){
		XEle_RegEventEx(hEle, pEvent);  return;
	}  delete pEvent;
}

// עԪ¼,ԱΪ¼ص.صʡԲ
#define XEle_RegEventCPP2(hEle, nEvent,pFunMember)  _XEle_RegEventCPP2(hEle, nEvent, this, pFunMember,#pFunMember);

template<typename T_ClassName, typename T_Member>
void _XEle_RegEventCPP1(HELE hEle, int nEvent, T_ClassName *pThis, T_Member pFun,char* pFunName)
{
	CEventEle< T_ClassName, T_Member > *pEvent = new CEventEle < T_ClassName, T_Member > ;
	if (pEvent->Bind2(pFunName,nEvent, pThis, pFun)){
		XEle_RegEventEx(hEle, pEvent);  return;
	}  delete pEvent;
}

// עԪ¼,ԱΪ¼ص.صʡԪhEle,
#define XEle_RegEventCPP1(hEle, nEvent,pFunMember)  _XEle_RegEventCPP1(hEle, nEvent, this, pFunMember,#pFunMember);

template<typename T_ClassName, typename T_Member>
void _XEle_RegEventCPP(HELE hEle, int nEvent, T_ClassName *pThis, T_Member pFun,char* pFunName)
{
	CEventEle< T_ClassName, T_Member > *pEvent = new CEventEle < T_ClassName, T_Member > ;
	if (pEvent->Bind(pFunName,nEvent, pThis, pFun)){

		XEle_RegEventEx(hEle, pEvent);  return;
	}  delete pEvent;
}


// עԪ¼,ԱΪ¼ص.صʡԪhEle,ʡԴ¼ԪؾhEventEle.
#define XEle_RegEventCPP(hEle, nEvent,pFunMember)  _XEle_RegEventCPP(hEle, nEvent, this, pFunMember, #pFunMember);

template<typename T_ClassName, typename T_Member>
BOOL _XEle_RemoveEventCPP(HELE hEle, int nEvent, T_ClassName *pThis, T_Member pFun,char* pFunName)
{
	CEventEle< T_ClassName, T_Member > Event;
	return Event.Remove(pFunName,hEle,nEvent, pThis, pFun);
}

//Ƴ¼C++
#define XEle_RemoveEventCPP(hEle,nEvent,pFunMember)  _XEle_RemoveEventCPP(hEle,nEvent,this,pFunMember,#pFunMember)

//////////////Cʽע///////////////////////////////////////////////
//עᵽָϢ,ʡԲ
template<typename T_Fun>
void XWnd_RegEventC1(HWINDOW hWindow, int nEvent, T_Fun *pFun)
{
	XWnd_RegEvent(hWindow, nEvent, pFun);
}

//עᵽָϢ,ԱʡԴhWindow
template<typename T_Fun>
void XWnd_RegEventC(HWINDOW hWindow, int nEvent, T_Fun *pFun)
{
	XWnd_RegEvent(hWindow, nEvent, pFun);
}

//עᵽָ¼,ʡԲ
template<typename T_Fun>
void XEle_RegEventC2(HELE hEle, int nEvent, T_Fun *pFun)
{
	XEle_RegEvent(hEle, nEvent, pFun);
}

//עᵽָ¼,ԱʡԪhEle
template<typename T_Fun>
void XEle_RegEventC1(HELE hEle, int nEvent, T_Fun *pFun)
{
	XEle_RegEvent(hEle, nEvent, pFun);
}

//עᵽָ¼,ԱʡԪhEle,ʡԴ¼ԪؾhEventEle
template<typename T_Fun>
void XEle_RegEventC(HELE hEle, int nEvent, T_Fun *pFun)
{
	XEle_RegEvent(hEle, nEvent, pFun);
}

//hEle      ¼Ԫؾ
//hEventEle ¼Ԫؾ
//////////////////////////////////////////////////////////////////////


XC_API int WINAPI XC_UnicodeToAnsi(const wchar_t *pIn, int inLen, char *pOut, int outLen);
XC_API int WINAPI XC_AnsiToUnicode(const char *pIn, int inLen, wchar_t *pOut, int outLen);
XC_API void WINAPI XC_DebugToFileInfo(const char *pInfo);
XC_API BOOL WINAPI XC_IsHELE(HELE hEle); //
XC_API BOOL WINAPI XC_IsHWINDOW(HWINDOW hWindow); //
XC_API BOOL WINAPI XC_IsShape(HXCGUI hShape); //
XC_API BOOL WINAPI XC_IsHXCGUI(HXCGUI hXCGUI,XC_OBJECT_TYPE nType);
XC_API BOOL WINAPI XC_IsSViewExtend(HELE hEle);  //жԪǷӹͼԪչԪ,ͼԪ
XC_API XC_OBJECT_TYPE WINAPI XC_GetObjectType(HXCGUI hXCGUI);
XC_API HXCGUI WINAPI XC_GetObjectByID(int nID); //ͨIDȡ
XC_API BOOL WINAPI XC_RectInRect(RECT *pRect1, RECT *pRect2);
XC_API void WINAPI XC_CombineRect(RECT *pDest, RECT *pSrc1, RECT *pSrc2);
XC_API void WINAPI XC_ShowLayoutFrame(BOOL bShow);
XC_API void WINAPI XC_SetLayoutFrameColor(COLORREF color);
XC_API HXCGUI WINAPI XC_LoadLayout(const wchar_t *pFileName);
XC_API BOOL WINAPI XC_LoadResource(const wchar_t *pFileName,const wchar_t *pDir=NULL);
XC_API template_info_i* WINAPI XC_TemplateLoad(XC_OBJECT_TYPE nType,const wchar_t* pFileName);  //ģ ģ
XC_API void WINAPI XC_TemplateDestroy(template_info_i* pInfo);
XC_API BOOL WINAPI XInitXCGUI(wchar_t *pText = NULL);
XC_API void WINAPI XRunXCGUI();
XC_API void WINAPI XExitXCGUI();
XC_API HELE WINAPI XBtn_Create(int x, int y, int cx, int cy,const wchar_t *pName, HXCGUI hParent = NULL);
XC_API BOOL WINAPI XBtn_IsCheck(HELE hEle); //ťǷѡ
XC_API BOOL WINAPI XBtn_SetCheck(HELE hEle, BOOL bCheck);
XC_API void WINAPI XBtn_SetState(HELE hEle,int nState);
XC_API int  WINAPI XBtn_GetState(HELE hEle);
XC_API void WINAPI XBtn_SetStyle(HELE hEle, int  nStyle);
XC_API int  WINAPI XBtn_GetStyle(HELE hEle);
XC_API void WINAPI XBtn_SetType(HELE hEle,int type);
XC_API int  WINAPI XBtn_GetType(HELE hEle);
XC_API void WINAPI XBtn_SetGroupID(HELE hEle,int nID);
XC_API int  WINAPI XBtn_GetGroupID(HELE hEle);
XC_API void WINAPI XBtn_SetBindEle(HELE hEle,HELE hBindEle);
XC_API HELE WINAPI XBtn_GetBindEle(HELE hEle);
XC_API void WINAPI XBtn_SetTextAlign(HELE hEle,int flag);
XC_API int  WINAPI XBtn_GetTextAlign(HELE hEle);
XC_API void WINAPI XBtn_SetIconAlign(HELE hEle,int align);
XC_API void WINAPI XBtn_SetOffset(HELE hEle,int x,int y);
XC_API void WINAPI XBtn_SetOffsetIcon(HELE hEle,int x,int y);
XC_API void WINAPI XBtn_SetIconSpace(HELE hEle, int size);
XC_API void WINAPI XBtn_GetText(HELE hEle,out_ wchar_t *pOut,int len);
XC_API void WINAPI XBtn_SetText(HELE hEle,in_ const wchar_t *pName);
XC_API void WINAPI XBtn_SetImageLeave(HELE hEle,HIMAGE hImage);  //뿪ʱͼƬ
XC_API void WINAPI XBtn_SetImageStay(HELE hEle,HIMAGE hImage);   //ͣʱͼƬ
XC_API void WINAPI XBtn_SetImageDown(HELE hEle,HIMAGE hImage);   //갴ʱͼƬ
XC_API void WINAPI XBtn_SetImageCheck(HELE hEle,HIMAGE hImage);  //ѡʱͼƬ
XC_API void WINAPI XBtn_SetImageDisable(HELE hEle,HIMAGE hImage); //ť״̬ͼƬ
XC_API void WINAPI XBtn_SetIcon(HELE hEle,HIMAGE hImage);
XC_API HELE WINAPI XComboBox_Create(int x, int y, int cx, int cy, HXCGUI hParent = NULL);
XC_API BOOL  WINAPI XComboBox_SetSelItem(HELE hEle,int iIndex);
XC_API void WINAPI XComboBox_BindApapter(HELE hEle,HXCGUI hAdapter);
XC_API void WINAPI XComboBox_SetItemTemplateXML(HELE hEle,const wchar_t* pXmlFile);
XC_API void WINAPI XComboBox_EnableDrawButton(HELE hEle,BOOL bEnable);
XC_API void WINAPI XComboBox_SetImageStay(HELE hEle,HIMAGE hImage);
XC_API void WINAPI XComboBox_SetImageDown(HELE hEle,HIMAGE hImage);
XC_API void WINAPI XAdapter_Destroy(HXCGUI hAdapter);
XC_API HXCGUI WINAPI XAdapterListView_Create();
XC_API int  WINAPI XAdapterListView_Group_AddColumn(HXCGUI hAdapter,const wchar_t *pName);
XC_API int  WINAPI XAdapterListView_Group_AddItemText(HXCGUI hAdapter,const wchar_t *pValue);
XC_API int  WINAPI XAdapterListView_Group_AddItemTextEx(HXCGUI hAdapter,const wchar_t* pName,const wchar_t *pValue);
XC_API int  WINAPI XAdapterListView_Group_AddItemImage(HXCGUI hAdapter,HIMAGE hImage);
XC_API int  WINAPI XAdapterListView_Group_AddItemImageEx(HXCGUI hAdapter,const wchar_t* pName,HIMAGE hImage);
XC_API int  WINAPI XAdapterListView_Item_AddColumn(HXCGUI hAdapter,const wchar_t *pName);  //
XC_API int  WINAPI XAdapterListView_Item_AddItemText(HXCGUI hAdapter,int iGroup,const wchar_t *pValue);
XC_API int  WINAPI XAdapterListView_Item_AddItemTextEx(HXCGUI hAdapter,int iGroup,const wchar_t *pName,const wchar_t *pValue);
XC_API int  WINAPI XAdapterListView_Item_AddItemImage(HXCGUI hAdapter,int iGroup,HIMAGE hImage);
XC_API int  WINAPI XAdapterListView_Item_AddItemImageEx(HXCGUI hAdapter,int iGroup,const wchar_t *pName,HIMAGE hImage);
XC_API BOOL WINAPI XAdapterListView_Item_SetText(HXCGUI hAdapter,int iGroup,int iItem,int iColumn,const wchar_t* pValue);
XC_API BOOL WINAPI XAdapterListView_Item_SetTextEx(HXCGUI hAdapter,int iGroup,int iItem,const wchar_t *pName,const wchar_t* pValue);
XC_API BOOL WINAPI XAdapterListView_Item_SetImage(HXCGUI hAdapter,int iGroup,int iItem,int iColumn,HIMAGE hImage);
XC_API BOOL WINAPI XAdapterListView_Item_SetImageEx(HXCGUI hAdapter,int iGroup,int iItem,const wchar_t *pName,HIMAGE hImage);
XC_API void WINAPI XAdapterListView_DeleteAll(HXCGUI hAdapter);
XC_API BOOL WINAPI XAdapterListView_Item_GetTextEx(HXCGUI hAdapter,int iGroup,int iItem,const wchar_t* pName,out_ wchar_t* pOut,int nOutLen);
XC_API HIMAGE WINAPI XAdapterListView_Item_GetImageEx(HXCGUI hAdapter,int iGroup,int iItem,const wchar_t* pName);
XC_API HXCGUI WINAPI XAdapterTable_Create();
XC_API int WINAPI XAdapterTable_AddColumn(HXCGUI hAdapter,const wchar_t* pName);
XC_API int WINAPI XAdapterTable_AddItemText(HXCGUI hAdapter,const wchar_t* pValue);
XC_API int WINAPI XAdapterTable_AddItemTextEx(HXCGUI hAdapter,const wchar_t* pName,const wchar_t* pValue);
XC_API int WINAPI XAdapterTable_AddItemImage(HXCGUI hAdapter,HIMAGE hImage);
XC_API int WINAPI XAdapterTable_AddItemImageEx(HXCGUI hAdapter,const wchar_t* pName,HIMAGE hImage);
XC_API BOOL WINAPI XAdapterTable_InsertItemText(HXCGUI hAdapter,int iItem,const wchar_t* pValue);
XC_API BOOL WINAPI XAdapterTable_InsertItemTextEx(HXCGUI hAdapter,int iItem,const wchar_t* pName,const wchar_t* pValue);
XC_API BOOL WINAPI XAdapterTable_InsertItemImage(HXCGUI hAdapter,int iItem,HIMAGE hImage);
XC_API BOOL WINAPI XAdapterTable_InsertItemImageEx(HXCGUI hAdapter,int iItem,const wchar_t* pName,HIMAGE hImage);
XC_API BOOL WINAPI XAdapterTable_SetItemText(HXCGUI hAdapter,int iItem,int iColumn,const wchar_t* pValue);
XC_API BOOL WINAPI XAdapterTable_SetItemTextEx(HXCGUI hAdapter,int iItem,const wchar_t* pName,const wchar_t* pValue);
XC_API BOOL WINAPI XAdapterTable_SetItemImage(HXCGUI hAdapter,int iItem,int iColumn,HIMAGE hImage);
XC_API BOOL WINAPI XAdapterTable_SetItemImageEx(HXCGUI hAdapter,int iItem,const wchar_t* pName,HIMAGE hImage);
XC_API BOOL WINAPI XAdapterTable_DeleteItem(HXCGUI hAdapter,int iItem);
XC_API BOOL WINAPI XAdapterTable_DeleteItemEx(HXCGUI hAdapter,int iItem,int nCount);
XC_API int WINAPI XAdapterTable_GetCount(HXCGUI hAdapter);
XC_API int WINAPI XAdapterTable_GetCountColumn(HXCGUI hAdapter);
XC_API BOOL WINAPI XAdapterTable_GetItemText(HXCGUI hAdapter,int iItem,int iColumn,out_ wchar_t* pOut,int nOutLen);
XC_API HIMAGE WINAPI XAdapterTable_GetItemImage(HXCGUI hAdapter,int iItem,int iColumn);
XC_API BOOL WINAPI XAdapterTable_GetItemTextEx(HXCGUI hAdapter,int iItem,const wchar_t* pName,out_ wchar_t* pOut,int nOutLen);
XC_API HIMAGE WINAPI XAdapterTable_GetItemImageEx(HXCGUI hAdapter,int iItem,const wchar_t* pName);
XC_API HXCGUI WINAPI XAdapterTree_Create();
XC_API int WINAPI XAdapterTree_AddColumn(HXCGUI hAdapter,const wchar_t* pName);
XC_API int WINAPI XAdapterTree_InsertItemText(HXCGUI hAdapter,const wchar_t* pValue,int nParentID=XC_ID_ROOT,int insertID=XC_ID_LAST);
XC_API int WINAPI XAdapterTree_InsertItemTextEx(HXCGUI hAdapter,const wchar_t* pName,const wchar_t* pValue,int nParentID=XC_ID_ROOT,int insertID=XC_ID_LAST);
XC_API int WINAPI XAdapterTree_InsertItemImage(HXCGUI hAdapter,HIMAGE hImage,int nParentID=XC_ID_ROOT,int insertID=XC_ID_LAST);
XC_API int WINAPI XAdapterTree_InsertItemImageEx(HXCGUI hAdapter,const wchar_t* pName,HIMAGE hImage,int nParentID=XC_ID_ROOT,int insertID=XC_ID_LAST);
XC_API int WINAPI XAdapterTree_GetCount(HXCGUI hAdapter);
XC_API int WINAPI XAdapterTree_GetCountColumn(HXCGUI hAdapter);
XC_API BOOL WINAPI XAdapterTree_SetItemText(HXCGUI hAdapter,int nID,int iColumn,const wchar_t* pValue);
XC_API BOOL WINAPI XAdapterTree_SetItemTextEx(HXCGUI hAdapter,int nID,const wchar_t* pName,const wchar_t* pValue);
XC_API BOOL WINAPI XAdapterTree_SetItemImage(HXCGUI hAdapter,int nID,int iColumn,HIMAGE hImage);
XC_API BOOL WINAPI XAdapterTree_SetItemImageEx(HXCGUI hAdapter,int nID,const wchar_t* pName,HIMAGE hImage);
XC_API BOOL WINAPI XAdapterTree_GetItemTextEx(HXCGUI hAdapter,int nID,const wchar_t* pName,out_ wchar_t* pOut,int nOutLen);
XC_API HIMAGE WINAPI XAdapterTree_GetItemImageEx(HXCGUI hAdapter,int nID,const wchar_t* pName);
XC_API HXCGUI WINAPI XAdapterMap_Create();
XC_API BOOL WINAPI XAdapterMap_AddItemText(HXCGUI hAdapter,const wchar_t* pName,const wchar_t* pValue);
XC_API BOOL WINAPI XAdapterMap_AddItemImage(HXCGUI hAdapter,const wchar_t* pName,HIMAGE hImage);
XC_API int  WINAPI XAdapterMap_GetCount(HXCGUI hAdapter);
XC_API BOOL WINAPI XAdapterMap_GetItemText(HXCGUI hAdapter,const wchar_t* pName,out_ wchar_t* pOut,int nOutLen);
XC_API HIMAGE WINAPI XAdapterMap_GetItemImage(HXCGUI hAdapter,const wchar_t* pName);
XC_API void WINAPI xtrace(const char *pFormat, ...);
XC_API void WINAPI xtracew(const wchar_t *pFormat, ...);
XC_API HDRAW WINAPI XDraw_Create(HDC hdc); //
XC_API void  WINAPI XDraw_Destroy(HDRAW hDraw); //
XC_API void  WINAPI XDraw_SetOffset(HDRAW hDraw, int x, int y); //ƫ
XC_API void  WINAPI XDraw_GetOffset(HDRAW hDraw, out_ int *pX, out_ int *pY); //ȡƫ
XC_API void  WINAPI XDraw_RestoreGDIOBJ(HDRAW hDraw);  //ԭ״̬,ͷû󶨵GDI
XC_API HDC   WINAPI XDraw_GetHDC(HDRAW hDraw);
XC_API void  WINAPI XDraw_SetBrushColor(HDRAW hDraw, COLORREF color,BYTE alpha=254);
XC_API void  WINAPI XDraw_SetTextAlign(HDRAW hDraw, int nFlag);
XC_API void  WINAPI XDraw_SetFontX(HDRAW hDraw, HFONTX  hFontx);
XC_API void  WINAPI XDraw_SetFont(HDRAW hDraw, int size);
XC_API void  WINAPI XDraw_SetFont2(HDRAW hDraw, const wchar_t* pName,int size);
XC_API void  WINAPI XDraw_SetFont3(HDRAW hDraw, LOGFONT* pLogFont);
XC_API int  WINAPI XDraw_SetBkMode(HDRAW hDraw, BOOL bTransparent);
XC_API HBRUSH WINAPI XDraw_CreateSolidBrush(HDRAW hDraw, COLORREF crColor);
XC_API HPEN WINAPI XDraw_CreatePen(HDRAW hDraw, int fnPenStyle, int nWidth, COLORREF crColor);
XC_API HRGN WINAPI XDraw_CreateRectRgn(HDRAW hDraw, int nLeftRect, int nTopRect, int nRightRect, int nBottomRect);
XC_API HRGN WINAPI XDraw_CreateRoundRectRgn(HDRAW hDraw, int nLeftRect, int nTopRect, int nRightRect, int nBottomRect, int nWidthEllipse, int nHeightEllipse);
XC_API HRGN WINAPI XDraw_CreatePolygonRgn(HDRAW hDraw, POINT *pPt, int cPoints, int fnPolyFillMode);
XC_API int WINAPI XDraw_SelectClipRgn(HDRAW hDraw, HRGN hRgn);
XC_API void WINAPI XDraw_FillRect(HDRAW hDraw, RECT *pRect);
XC_API void WINAPI XDraw_FillRectColor(HDRAW hDraw, RECT *pRect,COLORREF color,BYTE alpha=255);
XC_API BOOL WINAPI XDraw_FillRgn(HDRAW hDraw, HRGN hrgn, HBRUSH hbr);
XC_API void WINAPI XDraw_FillEllipse(HDRAW hDraw, RECT *pRect);
XC_API void WINAPI XDraw_DrawEllipse(HDRAW hDraw, RECT *pRect);
XC_API void WINAPI XDraw_FillRoundRect(HDRAW hDraw,RECT *pRect,int nWidth,int nHeight); //ԲǾ
XC_API void WINAPI XDraw_DrawRoundRect(HDRAW hDraw,RECT *pRect,int nWidth,int nHeight); //ԲǾα߿
XC_API BOOL WINAPI XDraw_Rectangle(HDRAW hDraw, int nLeftRect, int nTopRect, int nRightRect, int nBottomRect);
XC_API void WINAPI XDraw_DrawGroupBox_Rect(HDRAW hDraw, RECT *pRect,const wchar_t* pName,COLORREF textColor,BYTE textAlpha,POINT* pOffset);
XC_API void WINAPI XDraw_DrawGroupBox_RoundRect(HDRAW hDraw, RECT *pRect,const wchar_t* pName,COLORREF textColor,BYTE textAlpha,POINT* pOffset,int nWidth,int nHeight);
XC_API void WINAPI XDraw_GradientFill2(HDRAW hDraw, COLORREF color1, BYTE alpha1, COLORREF color2, BYTE alpha2, RECT *pRect, int mode);
XC_API BOOL WINAPI XDraw_GradientFill4(HDRAW hDraw, COLORREF color1, COLORREF color2, COLORREF color3, COLORREF color4, RECT *pRect, int mode);
XC_API BOOL WINAPI XDraw_FrameRgn(HDRAW hDraw, HRGN hrgn, HBRUSH hbr, int nWidth, int nHeight);
XC_API void  WINAPI XDraw_FrameRect(HDRAW hDraw, RECT *pRect);
XC_API void WINAPI XDraw_FocusRect(HDRAW hDraw, RECT *pRect);
XC_API void WINAPI XDraw_DrawLine(HDRAW hDraw,int x1,int y1,int x2,int y2);
XC_API BOOL WINAPI XDraw_MoveToEx(HDRAW hDraw, int X, int Y, LPPOINT lpPoint = NULL);
XC_API BOOL WINAPI XDraw_LineTo(HDRAW hDraw, int nXEnd, int nYEnd);
XC_API BOOL WINAPI XDraw_Polyline(HDRAW hDraw, in_ POINT *pArrayPt, int arrayPtSize);
XC_API void WINAPI XDraw_Dottedline(HDRAW hDraw, int x1, int y1, int x2, int y2);  //
XC_API COLORREF WINAPI XDraw_SetPixel(HDRAW hDraw, int X, int Y, COLORREF crColor);
XC_API void WINAPI XDraw_Check(HDRAW hDraw, int x, int y, COLORREF color, BOOL bCheck);
XC_API BOOL WINAPI XDraw_DrawIconEx(HDRAW hDraw, int xLeft, int yTop, HICON hIcon, int cxWidth, int cyWidth, UINT istepIfAniCur, HBRUSH hbrFlickerFreeDraw, UINT diFlags);
XC_API BOOL WINAPI XDraw_BitBlt(HDRAW hDrawDest, int nXDest, int nYDest, int nWidth, int nHeight, HDC hdcSrc, int nXSrc, int nYSrc, DWORD dwRop);
XC_API BOOL WINAPI XDraw_BitBlt2(HDRAW hDrawDest, int nXDest, int nYDest, int nWidth, int nHeight, HDRAW hDrawSrc, int nXSrc, int nYSrc, DWORD dwRop);
XC_API BOOL WINAPI XDraw_AlphaBlend(HDRAW hDraw, int nXOriginDest, int nYOriginDest, int nWidthDest, int nHeightDest, HDC hdcSrc, int nXOriginSrc,int nYOriginSrc, int nWidthSrc, int nHeightSrc, int alpha);
XC_API void WINAPI XDraw_TriangularArrow(HDRAW hDraw, HBRUSH hBrush, int align, int x, int y, int width, int height);
XC_API void WINAPI XDraw_Image(HDRAW hDraw, HIMAGE hImage, int x, int y);
XC_API void WINAPI XDraw_Image2(HDRAW hDraw, HIMAGE hImage, int x, int y, int width, int height);
XC_API void WINAPI XDraw_ImageStretch(HDRAW hDraw, HIMAGE hImage, int x, int y, int width, int height);
XC_API void WINAPI XDraw_ImageAdaptive(HDRAW hDraw, HIMAGE hImage, RECT *pRect);
XC_API void WINAPI XDraw_ImageExTile(HDRAW hDraw, HIMAGE hImage, RECT *pRect, int flag = 0);
XC_API void WINAPI XDraw_ImageSuper(HDRAW hDraw, HIMAGE hImage, RECT *pRect,BOOL bClip=FALSE);
XC_API void WINAPI XDraw_ImageSuper2(HDRAW hDraw, HIMAGE hImage, RECT *pRcDest, RECT *pSrcRect);
XC_API void WINAPI XDraw_DrawText(HDRAW hDraw, const wchar_t * lpString, int nCount, RECT* lpRect);
XC_API void WINAPI XDraw_DrawTextUnderline(HDRAW hDraw, const wchar_t * lpString, int nCount, RECT* lpRect,COLORREF colorLine,BYTE alphaLine=254);
XC_API void WINAPI XDraw_TextOut(HDRAW hDraw, int nXStart, int nYStart, const wchar_t * lpString, int cbString);
XC_API void WINAPI XDraw_TextOutA(HDRAW hDraw, int nXStart, int nYStart, const char * lpString);
XC_API void WINAPI XDraw_SetAlpha(HDRAW hDraw,BYTE alpha);  //͸ͨ
XC_API void WINAPI XDraw_SetAlphaEx(HDC hdc,BYTE alpha);  //͸ͨ
XC_API HELE WINAPI XEle_Create(int x, int y, int cx, int cy, HXCGUI hParent = NULL);
XC_API void WINAPI XEle_RegEventEx(HELE hEle, CEventBase* pEvent);
XC_API BOOL WINAPI XEle_RemoveEventEx(HELE hEle, CEventBase *pEvent);
XC_API void WINAPI XEle_RegEvent(HELE hEle, int nEvent, void *pFun);
XC_API BOOL WINAPI XEle_RemoveEvent(HELE hEle, int nEvent, void *pFun);
XC_API int  WINAPI XEle_SendEvent(HELE hEle, HELE hEventEle, int nEvent, WPARAM wParam, LPARAM lParam);
XC_API BOOL WINAPI XEle_PostEvent(HELE hEle, HELE hEventEle, int nEvent, WPARAM wParam, LPARAM lParam);
XC_API BOOL WINAPI XEle_IsShow(HELE hEle);
XC_API BOOL WINAPI XEle_IsEnable(HELE hEle);
XC_API BOOL WINAPI XEle_IsEnableFocus(HELE hEle);
XC_API BOOL WINAPI XEle_IsDrawFocus(HELE hEle);
XC_API BOOL WINAPI XEle_IsBorder(HELE hEle);
XC_API BOOL WINAPI XEle_IsEnableEvent_XE_PAINT_END(HELE hEle);
XC_API BOOL WINAPI XEle_IsMouseThrough(HELE hEle);
XC_API BOOL WINAPI XEle_IsBkTransparent(HELE hEle);
XC_API void WINAPI XEle_Enable(HELE hEle, BOOL bEnable);
XC_API void WINAPI XEle_EnableFocus(HELE hEle, BOOL bEnable);
XC_API void WINAPI XEle_EnableDrawFocus(HELE hEle, BOOL bEnable);
XC_API void WINAPI XEle_EnableEvent_XE_PAINT_END(HELE hEle,BOOL bEnable);
XC_API void WINAPI XEle_EnableBkTransparent(HELE hEle,BOOL bEnable);
XC_API void WINAPI XEle_EnableBorder(HELE hEle,BOOL bEnable);
XC_API void WINAPI XEle_EnableMouseThrough(HELE hEle,BOOL bEnable);
XC_API BOOL WINAPI XEle_SetRect(HELE hEle, RECT *pRect,BOOL bRedraw=FALSE);
XC_API void WINAPI XEle_SetRectLogic(HELE hEle, RECT *pRect, BOOL bRedraw=FALSE); //߼ģʽ
XC_API void WINAPI XEle_GetRect(HELE hEle, RECT *pRect);   //븸,۹۲ģʽ
XC_API void WINAPI XEle_GetRectLogic(HELE hEle, RECT *pRect); //븸,߼ģʽ
XC_API void WINAPI XEle_GetClientRect(HELE hEle, RECT *pRect);  //ϽΪ00
XC_API void WINAPI XEle_GetWndClientRect(HELE hEle,out_ RECT *pRect);
XC_API int  WINAPI XEle_GetWidth(HELE hEle);
XC_API int  WINAPI XEle_GetHeight(HELE hEle);
XC_API void WINAPI XEle_RectWndClientToEleClient(HELE hEle, in_out_ RECT *pRect);
XC_API void WINAPI XEle_PointWndClientToEleClient(HELE hEle, in_out_ POINT *pPt); 
XC_API void WINAPI XEle_RectClientToWndClient(HELE hEle,in_out_ RECT *pRect);
XC_API void WINAPI XEle_PointClientToWndClient(HELE hEle, in_out_ POINT *pPt);
XC_API BOOL WINAPI XEle_AddEle(HELE hEle, HELE hChildEle);
XC_API BOOL WINAPI XEle_InsertEle(HELE hEle, HELE hChildEle,HELE hDestEle);  //뵽ָԪǰ
XC_API void WINAPI XELE_RemoveEle(HELE hEle);
XC_API BOOL WINAPI XEle_AddShape(HELE hEle,HXCGUI hShape);
XC_API void WINAPI XEle_ShowEle(HELE hEle, BOOL bShow);
XC_API XC_OBJECT_TYPE WINAPI XEle_GetType(HELE hEle);
XC_API HWND WINAPI XEle_GetHWND(HELE hEle);
XC_API HWINDOW WINAPI XEle_GetHWINDOW(HELE hEle);
XC_API void WINAPI XEle_SetCursor(HELE hEle, HCURSOR hCursor);
XC_API HCURSOR WINAPI XEle_GetCursor(HELE hEle);
XC_API void WINAPI XEle_SetID(HELE hEle, int id);
XC_API int  WINAPI XEle_GetID(HELE hEle);
XC_API HELE WINAPI XEle_GetParentEle(HELE hEle);
XC_API void WINAPI XEle_SetBkColor(HELE hEle,COLORREF color,BYTE alpha=255); //ñɫ
XC_API COLORREF WINAPI XEle_GetBkColor(HELE hEle);
XC_API void  WINAPI XEle_SetBorderColor(HELE hEle, COLORREF color,BYTE alpha=255);
XC_API COLORREF WINAPI XEle_GetBorderColor(HELE hEle);
XC_API void WINAPI XEle_SetTextColor(HELE hEle, COLORREF color,BYTE alpha=254);
XC_API COLORREF WINAPI XEle_GetTextColor(HELE hEle);
XC_API void WINAPI XEle_SetFont(HELE hEle,HFONTX hFontx);
XC_API HFONTX WINAPI XEle_GetFont(HELE hEle);
XC_API void WINAPI XEle_SetAlpha(HELE hEle,BYTE alpha);
XC_API int  WINAPI XEle_GetChildCount(HELE hEle);
XC_API HELE WINAPI XEle_GetChildByIndex(HELE hEle,int index);
XC_API HELE WINAPI XEle_GetChildByID(HELE hEle,int id);
XC_API HELE WINAPI XEle_HitChildEle(HELE hEle,in_ POINT  *pPt);  //жĸԪ
XC_API void WINAPI XEle_BindLayoutObject(HELE hEle,HXCGUI hLayout);
XC_API HXCGUI WINAPI XEle_GetLayoutObject(HELE hEle);
XC_API void WINAPI XEle_SetUserData(HELE hEle,int nData);
XC_API int  WINAPI XEle_GetUserData(HELE hEle);
XC_API void WINAPI XEle_GetContentSize(HELE hEle,out_ SIZE* pSize);
XC_API void WINAPI XEle_SetCapture(HELE hEle,BOOL b);
XC_API void WINAPI XEle_SetLayoutWidth(HELE hEle,int nFlag,int nWidth);
XC_API void WINAPI XEle_SetLayoutHeight(HELE hEle,int nFlag,int nHeight);
XC_API void WINAPI XEle_GetLayoutWidth(HELE hEle, out_ int *pFlag,out_ int *pWidth);
XC_API void WINAPI XEle_GetLayoutHeight(HELE hEle, out_ int *pFlag,out_ int *pHeight);
XC_API void WINAPI XEle_RedrawEle(HELE hEle);
XC_API void WINAPI XEle_RedrawRect(HELE hEle,RECT *pRect);
XC_API void WINAPI XEle_Destroy(HELE hEle);  //
XC_API void WINAPI XEle_SetImage(HELE hEle,HIMAGE hImage);
XC_API void WINAPI XEle_EnableTransparentChannel(HELE hEle,BOOL bEnable);
XC_API int WINAPI XEle_GetTemplateListItemID(HELE hEle);  //ȡǰԪģʵ,бһ.
XC_API int WINAPI XEle_GetTemplateListItemGroupID(HELE hEle);
XC_API void WINAPI XEle_AdjustLayout(HELE hEle);
XC_API BOOL WINAPI XEle_RegEventTest(int nEvent,BYTE* pParamType); //صǷȷ
XC_API HFONTX WINAPI XFont_Create(int size);//
XC_API HFONTX WINAPI XFont_Create2(const wchar_t *pName=L"",int size=12,BOOL bBold=FALSE,BOOL bItalic=FALSE,BOOL bUnderline=FALSE,BOOL bStrikeOut=FALSE);
XC_API HFONTX WINAPI XFont_CreateEx(LOGFONTW *pFontInfo);
XC_API HFONTX WINAPI XFont_CreateFromHFONT(HFONT hFont);
XC_API void   WINAPI XFont_Destroy(HFONTX hFontX);  //
XC_API HFONT  WINAPI XFont_GetHFONT(HFONTX hFontX);
XC_API HWINDOW WINAPI XFrameWnd_Create(int x, int y, int cx, int cy, wchar_t *pTitle, HWND hWndParent, int XCStyle);  //
XC_API HWINDOW WINAPI XFrameWnd_CreateEx(DWORD dwExStyle, wchar_t* lpClassName, wchar_t* lpWindowName, DWORD dwStyle, int x, int y, int cx, int cy, HWND hWndParent, int XCStyle);  //
XC_API void WINAPI XFrameWnd_GetLayoutAreaRect(HWINDOW hWindow,out_ RECT *pRect); //ȡͻ
XC_API void WINAPI XFrameWnd_SetView(HWINDOW hWindow,HELE hEle);
XC_API BOOL WINAPI XFrameWnd_AddPane(HWINDOW hWindow,HELE hPaneDest,HELE hPaneNew,pane_align_type_ align=align_any);
XC_API HIMAGE WINAPI XImage_LoadFile(const wchar_t *pImageName,BOOL bStretch=FALSE);//ļмͼƬ
XC_API HIMAGE WINAPI XImage_LoadFileAdaptive(const wchar_t *pImageName,int leftSize,int topSize,int rightSize,int bottomSize);//ļмͼƬ
XC_API HIMAGE WINAPI XImage_LoadFileRect(const wchar_t *pImageName,int x,int y,int cx,int cy);  //ͼƬ,ָ
XC_API HIMAGE WINAPI XImage_LoadResAdaptive(int id,const wchar_t *pType,int leftSize,int topSize,int rightSize,int bottomSize);//ԴмͼƬ
XC_API HIMAGE WINAPI XImage_LoadRes(int id,const wchar_t *pType,BOOL bStretch=FALSE);//ԴмͼƬ
XC_API HIMAGE WINAPI XImage_LoadZip(const wchar_t *pZipFileName,const wchar_t *pImageName,const wchar_t *pPassword=NULL,BOOL bStretch=FALSE);//ZIPмͼƬ
XC_API HIMAGE WINAPI XImage_LoadZipAdaptive(const wchar_t *pZipFileName,const wchar_t *pImageName,const wchar_t *pPassword,int x1,int x2,int y1,int y2);//ZIPмͼƬ
XC_API HIMAGE WINAPI XImage_LoadZipRect(const wchar_t *pZipFileName,const wchar_t *pImageName,const wchar_t *pPassword,int x,int y,int cx,int cy);
XC_API HIMAGE WINAPI XImage_LoadMemory(void* pBuffer,int nSize,BOOL bStretch);
XC_API HIMAGE WINAPI XImage_LoadMemoryRect(void* pBuffer,int nSize,int x,int y,int cx,int cy,BOOL bStretch);
XC_API HIMAGE WINAPI XImage_LoadMemoryAdaptive(void* pBuffer,int nSize,int leftSize,int topSize,int rightSize,int bottomSize);
XC_API HIMAGE WINAPI XImage_LoadFromImage(void *pImage);
XC_API HIMAGE WINAPI XImage_LoadFileFromExtractIcon(const wchar_t *pImageName);
XC_API HIMAGE WINAPI XImage_LoadFileFromHICON(HICON hIcon);
XC_API HIMAGE WINAPI XImage_LoadFileFromHBITMAP(HBITMAP hBitmap);
XC_API BOOL WINAPI XImage_IsStretch(HIMAGE hImage);   //ǷͼƬ
XC_API BOOL WINAPI XImage_IsAdaptive(HIMAGE hImage);  //ǷΪӦͼƬ
XC_API BOOL WINAPI XImage_IsTile(HIMAGE hImage);      //ǷΪƽͼƬ
XC_API BOOL WINAPI XImage_SetDrawType(HIMAGE hImage,int type);//ͼƬ
XC_API BOOL WINAPI XImage_SetDrawTypeAdaptive(HIMAGE hImage,int leftSize,int topSize,int rightSize,int bottomSize);//ͼƬӦ
XC_API void WINAPI XImage_SetTranColor(HIMAGE hImage,COLORREF color); //͸ɫ
XC_API void WINAPI XImage_SetTranColorEx(HIMAGE hImage,COLORREF color,BYTE tranColor); //͸ɫ
XC_API void WINAPI XImage_EnableTranColor(HIMAGE hImage,BOOL bEnable); //͸ɫ
XC_API void WINAPI XImage_EnableAutoDestroy(HIMAGE hImage,BOOL bEnable); //ûرԶ,UIԪعʱЧ
XC_API void WINAPI XImage_EnableCenter(HIMAGE hImage,BOOL bCenter); //bCenter
XC_API BOOL WINAPI XImage_IsCenter(HIMAGE hImage);
XC_API int WINAPI XImage_GetDrawType(HIMAGE hImage); //ȡͼƬ
XC_API int WINAPI XImage_GetWidth(HIMAGE hImage);
XC_API int WINAPI XImage_GetHeight(HIMAGE hImage);
XC_API void WINAPI XImage_Release(HIMAGE hImage);
XC_API void WINAPI XImage_Destroy(HIMAGE hImage);
XC_API HXCGUI WINAPI XLayout_Create();
XC_API void WINAPI XLayout_Destroy(HXCGUI hLayout);
XC_API void WINAPI XLayout_AddEle(HXCGUI hLayout,HELE hEle);
XC_API void WINAPI XLayout_AddLayoutObject(HXCGUI hLayout,HXCGUI hLayoutObject);
XC_API void WINAPI XLayout_AddShape(HXCGUI hLayout,HXCGUI hShape);
XC_API void WINAPI XLayout_RemoveChild(HXCGUI hLayout,HXCGUI hChild);
XC_API void WINAPI XLayout_AdjustLayout(HXCGUI hLayout);
XC_API void WINAPI XLayout_SetRectFrame(HXCGUI hLayout,RECT *pRect);
XC_API void WINAPI XLayout_GetRect(HXCGUI hLayout,out_ RECT *pRect);
XC_API void WINAPI XLayout_GetRectFrame(HXCGUI hLayout,out_ RECT *pRect);
XC_API HWINDOW WINAPI XLayout_GetWindow(HXCGUI hLayout);
XC_API HELE WINAPI XLayout_GetEle(HXCGUI hLayout);
XC_API HXCGUI WINAPI XLayout_GetParentLayout(HXCGUI hLayout);
XC_API void WINAPI XLayout_SetID(HXCGUI hLayout,int nID);
XC_API void WINAPI XLayout_SetHorizon(HXCGUI hLayout,BOOL bHorizon);
XC_API void WINAPI XLayout_SetAlignH(HXCGUI hLayout,layout_align_ nFlag);
XC_API void WINAPI XLayout_SetAlignV(HXCGUI hLayout,layout_align_ nFlag);
XC_API void WINAPI XLayout_SetPadding(HXCGUI hLayout,int left,int top,int right,int bottom);
XC_API void WINAPI XLayout_SetSpace(HXCGUI hLayout,int nSpace);
XC_API void WINAPI XLayout_SetLayoutWidth(HXCGUI hLayout,int nFlag,int nWidth);
XC_API void WINAPI XLayout_SetLayoutHeight(HXCGUI hLayout,int nFlag,int nHeight);
XC_API void WINAPI XLayout_GetLayoutWidth(HXCGUI hLayout,out_ int *pFlag,out_ int *pWidth);
XC_API void WINAPI XLayout_GetLayoutHeight(HXCGUI hLayout,out_ int *pFlag,out_ int *pHeight);
XC_API int WINAPI XLayout_GetWidth(HXCGUI hLayout);
XC_API int WINAPI XLayout_GetHeight(HXCGUI hLayout);
XC_API int WINAPI XLayout_GetWidthIn(HXCGUI hLayout);
XC_API int WINAPI XLayout_GetHeightIn(HXCGUI hLayout);
XC_API void WINAPI XLayout_GetContentSize(HXCGUI hLayout,out_ SIZE* pSize);
XC_API void WINAPI XLayout_ShowLayout(HXCGUI hLayout,BOOL bShow);
XC_API int WINAPI XLayout_GetChildCount(HXCGUI hLayout);
XC_API XC_OBJECT_TYPE WINAPI XLayout_GetChildType(HXCGUI hLayout,int index);
XC_API HXCGUI WINAPI XLayout_GetChild(HXCGUI hLayout,int index);
XC_API HELE WINAPI XListBox_Create(int x, int y, int cx, int cy,HXCGUI hParent=NULL);
XC_API void WINAPI XListBox_SetStyle(HELE hEle, int style);
XC_API BOOL WINAPI XListBox_SetItemData(HELE hEle, int iItem, int nUserData);
XC_API int  WINAPI XListBox_GetItemData(HELE hEle,int iItem);
XC_API BOOL WINAPI XListBox_SetItemInfo(HELE hEle,int iItem,in_ listBox_item_Info_i *pItem);
XC_API BOOL WINAPI XListBox_GetItemInfo(HELE hEle,int iItem,out_ listBox_item_Info_i *pItem);
XC_API void WINAPI XListBox_SetItemColor(HELE hEle,COLORREF color,BYTE alpha=255);
XC_API COLORREF WINAPI XListBox_GetItemColor(HELE hEle);
XC_API void WINAPI XListBox_SetItemColorSel(HELE hEle,COLORREF color,BYTE alpha=255);
XC_API COLORREF WINAPI XListBox_GetItemColorSel(HELE hEle);
XC_API void WINAPI XListBox_SetItemColorStay(HELE hEle,COLORREF color,BYTE alpha=255);
XC_API COLORREF WINAPI XListBox_GetItemColorStay(HELE hEle);
XC_API BOOL WINAPI XListBox_SetSelectItem(HELE hEle,int iItem);
XC_API int  WINAPI XListBox_GetSelectItem(HELE hEle);
XC_API BOOL WINAPI XListBox_CancelSelectItem(HELE hEle,int iItem);
XC_API BOOL WINAPI XListBox_CancelSelectAll(HELE hEle);
XC_API int  WINAPI XListBox_GetSelectAll(HELE hEle,out_ int *pArray,int nArraySize);
XC_API int  WINAPI XListBox_GetSelectCount(HELE hEle);
XC_API int  WINAPI XListBox_GetItemMouseStay(HELE hEle);
XC_API BOOL WINAPI XListBox_SelectAll(HELE hEle);
XC_API void WINAPI XListBox_SetItemHeightDefault(HELE hEle,int nHeight,int nSelHeight);
XC_API void WINAPI XListBox_GetItemHeightDefault(HELE hEle,out_ int *pHeight,out_ int *pSelHeight);
XC_API int  WINAPI XListBox_HitTest(HELE hEle,POINT *pPt);
XC_API int  WINAPI XListBox_HitTestOffset(HELE hEle,POINT *pPt); //Զӹͼƫ
XC_API BOOL WINAPI XListBox_SetItemTemplateXML(HELE hEle,const wchar_t* pXmlFile);
XC_API HXCGUI WINAPI XListBox_GetTemplateObject(HELE hEle,int iItem,int nTempItemID);
XC_API void WINAPI XListBox_EnableMultiSel(HELE hEle,BOOL bEnable);
XC_API void WINAPI XListBox_BindAdapter(HELE hEle,HXCGUI hAdapter);
XC_API HXCGUI WINAPI XListBox_GetAdapter(HELE hEle);
XC_API HELE WINAPI XList_Create(int x,int y,int cx,int cy,HXCGUI hParent=NULL);
XC_API int WINAPI XList_AddColumn(HELE hEle,int width); //
XC_API int WINAPI XList_InsertColumn(HELE hEle,int width,int iItem);
XC_API void WINAPI XList_SetStyle(HELE hEle,int style);
XC_API void WINAPI XList_SetColumnWidth(HELE hEle,int iItem,int width);
XC_API void WINAPI XList_SetColumnMinWidth(HELE hEle,int iItem,int width);
XC_API BOOL WINAPI XList_DeleteColumn(HELE hEle,int iItem);
XC_API void WINAPI XList_DeleteColumnAll(HELE hEle);
XC_API BOOL WINAPI XList_SetItemData(HELE hEle,int iItem,int iSubItem,int data);
XC_API int  WINAPI XList_GetItemData(HELE hEle,int iItem,int iSubItem);
XC_API BOOL WINAPI XList_SetSelectItem(HELE hEle,int iItem);
XC_API int  WINAPI XList_GetSelectItem(HELE hEle);
XC_API int  WINAPI XList_GetSelectAll(HELE hEle,out_ int *pArray,int nArraySize);
XC_API HELE WINAPI XList_GetHeaderHELE(HELE hEle);
XC_API void WINAPI XList_BindAdapter(HELE hEle,HXCGUI hAdapter);
XC_API void WINAPI XList_BindAdapterHeader(HELE hEle,HXCGUI hAdapter);
XC_API HXCGUI WINAPI XList_GetAdapter(HELE hEle);
XC_API BOOL WINAPI XList_SetItemTemplateXML(HELE hEle,const wchar_t* pXmlFile);
XC_API HXCGUI WINAPI XList_GetTemplateObject(HELE hEle,int iItem,int nTempItemID); //ͨģID,ȡʵģIDӦĶ.
XC_API void WINAPI XList_SetHeaderHeight(HELE hEle,int height);
XC_API int  WINAPI XList_GetHeaderHeight(HELE hEle);
XC_API void WINAPI XList_SetItemColor(HELE hEle,COLORREF color,BYTE alpha=255);
XC_API void WINAPI XList_SetItemColorSel(HELE hEle,COLORREF color,BYTE alpha=255);
XC_API void WINAPI XList_SetItemColorStay(HELE hEle,COLORREF color,BYTE alpha=255);
XC_API COLORREF WINAPI XList_GetItemColor(HELE hEle);
XC_API COLORREF WINAPI XList_GetItemColorSel(HELE hEle);
XC_API COLORREF WINAPI XList_GetItemColorStay(HELE hEle);
XC_API void WINAPI XList_SetItemHeightDefault(HELE hEle,int nHeight,int nSelHeight);
XC_API void WINAPI XList_GetItemHeightDefault(HELE hEle,out_ int *pHeight,out_ int *pSelHeight);
XC_API BOOL WINAPI XList_HitTest(HELE hEle,POINT *pPt,out_ int *piItem,out_ int *piSubItem);
XC_API BOOL WINAPI XList_HitTestOffset(HELE hEle,POINT *pPt,out_ int *piItem,out_ int *piSubItem);
XC_API void WINAPI XList_RefreshData(HELE hEle);
XC_API HELE WINAPI XListView_Create(int x, int y, int cx, int cy,HXCGUI hParent=NULL);
XC_API void WINAPI XListView_BindAdapter(HELE hEle,HXCGUI hAdapter);
XC_API HXCGUI WINAPI XListView_GetAdapter(HELE hEle);
XC_API BOOL WINAPI XListView_SetItemTemplateXML(HELE hEle,const wchar_t* pXmlFile);
XC_API HXCGUI WINAPI XListView_GetTemplateObject(HELE hEle,int iGroup,int iItem,int nTempItemID);
XC_API HXCGUI WINAPI XListView_GetTemplateObjectGroup(HELE hEle,int iGroup,int nTempItemID);
XC_API BOOL WINAPI XListView_HitTest(HELE hEle,in_ POINT* pPt,out_ int* pOutGroup,out_ int* pOutItem);
XC_API int  WINAPI XListView_HitTestOffset(HELE hEle,in_ POINT *pPt,out_ int* pOutGroup,out_ int* pOutItem); //Զӹͼƫ
XC_API BOOL WINAPI XListView_SetSelectItem(HELE hEle,int iGroup,int iItem);
XC_API BOOL WINAPI XListView_GetSelectItem(HELE hEle,int *piGroup,int *piItem);
XC_API void WINAPI XListView_SetColumnSpace(HELE hEle,int space); //м
XC_API void WINAPI XListView_SetRowSpace(HELE hEle,int space); //м
XC_API void WINAPI XListView_SetAlignSizeLeft(HELE hEle,int size);
XC_API void WINAPI XListView_SetAlignSizeTop(HELE hEle,int size);
XC_API void WINAPI XListView_SetItemSize(HELE hEle,int width,int height);
XC_API void WINAPI XListView_GetItemSize(HELE hEle,SIZE* pSize);
XC_API void WINAPI XListView_SetGroupHeight(HELE hEle,int height);
XC_API int  WINAPI XListView_GetGroupHeight(HELE hEle);
XC_API void WINAPI XListView_SetItemColorSel(HELE hEle,COLORREF color,BYTE alpha=255);
XC_API void WINAPI XListView_SetItemBorderColorSel(HELE hEle,COLORREF color,BYTE alpha=255);
XC_API void WINAPI XListView_SetItemColorStay(HELE hEle,COLORREF color,BYTE alpha=255);
XC_API void WINAPI XListView_SetItemBorderColorStay(HELE hEle,COLORREF color,BYTE alpha=255);
XC_API void WINAPI XListView_SetItemColorLeave(HELE hEle,COLORREF color,BYTE alpha=255);
XC_API void WINAPI XListView_SetItemBorderColorLeave(HELE hEle,COLORREF color,BYTE alpha=255);
XC_API BOOL WINAPI XListView_ExpandGroup(HELE hEle,int iGroup,BOOL bExpand);
XC_API HELE WINAPI XMenuBar_Create(int x, int y, int cx, int cy, HXCGUI hParent = NULL);
XC_API int  WINAPI XMenuBar_AddButton(HELE hEle, wchar_t *pText);     //ӵ˵ť
XC_API void WINAPI XMenuBar_AddMenuItem(HELE hEle, int index, int id, wchar_t *pText, int parentId = XC_ID_ROOT, int uFlags = 0);
XC_API void WINAPI XMenuBar_InsertMenuItem(HELE hEle, int index, int id, wchar_t *pText, int uFlags, int insertID); //˵,뵽IDΪinsertID˵ǰλ
XC_API void WINAPI XMenuBar_SetButtonHeight(HELE hEle,int height);
XC_API HMENUX WINAPI XMenu_Create();
XC_API void WINAPI XMenu_AddItem(HMENUX hMenu, int nID,const wchar_t *pText, int parentId = XC_ID_ROOT, int uFlags = 0); //Ӳ˵
XC_API void WINAPI XMenu_InsertItem(HMENUX hMenu, int id, wchar_t *pText, int uFlags, int insertID);
XC_API void WINAPI XMenu_SetAutoDestroy(HMENUX hMenu, BOOL bAuto); //ǷԶٶ,Ĭϵ˵رպԶ
XC_API BOOL WINAPI XMenu_Popup(HMENUX hMenu, HWND hParentWnd, int x, int y, HELE hParentEle=NULL, int uFlags = NULL); //˵
XC_API void WINAPI XMenu_DestroyMenu(HMENUX hMenu);
XC_API void WINAPI XMenu_CloseMenu(HMENUX hMenu);
XC_API BOOL WINAPI XMenu_SetItemText(HMENUX hMenu,int id,const wchar_t *pText); //ı
XC_API BOOL WINAPI XMenu_SetItemFlags(HMENUX hMenu,int id,int uFlags);   //
XC_API void WINAPI XMenu_SetItemHeight(HMENUX hMenu,int height); //ò˵߶
XC_API int  WINAPI XMenu_GetItemHeight(HMENUX hMenu);
XC_API int  WINAPI XMenu_GetLeftWidth(HMENUX hMenu); //ȡ
XC_API int  WINAPI XMenu_GetLeftSpaceText(HMENUX hMenu);  //ȡ˵ı
XC_API HWINDOW WINAPI XModalWnd_Create(int nWidth,int nHeight,wchar_t *pTitle,HWND hWndParent,int XCStyle=XC_SY_MODAL_WINDOW);
XC_API void WINAPI XModalWnd_EnableAutoClose(HWINDOW hWindow,BOOL bEnable);
XC_API int  WINAPI XModalWnd_DoModal(HWINDOW hWindow);     //ģ̬
XC_API void WINAPI XModalWnd_EndModal(HWINDOW hWindow,int nResult); //ֹ
XC_API HELE WINAPI XPane_Create(const wchar_t *pName,int nWidth,int nHeight,HWINDOW hFrameWnd=NULL,int id=0);
XC_API void WINAPI XPane_SetView(HELE hEle, HELE hView);
XC_API HELE WINAPI XProgBar_Create(int x, int y, int cx, int cy,HXCGUI hParent=NULL);
XC_API void WINAPI XProgBar_SetRange(HELE hEle,int range);
XC_API int WINAPI XProgBar_GetRange(HELE hEle);
XC_API void WINAPI XProgBar_SetSpaceTwo(HELE hEle,int leftSize,int rightSize);
XC_API void WINAPI XProgBar_SetPos(HELE hEle,int pos);
XC_API int  WINAPI XProgBar_GetPos(HELE hEle);
XC_API void WINAPI XProgBar_SetHorizon(HELE hEle,BOOL bHorizon);
XC_API void WINAPI XProgBar_SetImageLoad(HELE hEle,HIMAGE hImage);
XC_API HELE WINAPI XPGrid_Create(int x,int y,int cx,int cy,HXCGUI hParent=NULL);
XC_API int  WINAPI XPGrid_AddItem(HELE hEle,const wchar_t *pName,int type,int nParentID=XC_ID_ROOT); //
XC_API int  WINAPI XPGrid_AddItemString(HELE hEle,const wchar_t *pName,const wchar_t *pValue,int nParentID=XC_ID_ROOT);
XC_API void WINAPI XPGrid_DeleteAll(HELE hEle);
XC_API HELE WINAPI XPGrid_GetItemHELE(HELE hEle,int nItemID);
XC_API void WINAPI XPGrid_SetWidth(HELE hEle,int nWidth);
XC_API BOOL WINAPI XPGrid_SetItemValue(HELE hEle,int nItemID,const wchar_t* pValue);
XC_API BOOL WINAPI XPGrid_SetItemValueInt(HELE hEle,int nItemID,int nValue);
XC_API const wchar_t* WINAPI XPGrid_GetItemValue(HELE hEle,int nItemID);
XC_API int  WINAPI XPGrid_HitTest(HELE hEle,POINT *pPt,BOOL *pbExpandButton);
XC_API int  WINAPI XPGrid_HitTestOffset(HELE hEle,POINT *pPt,BOOL *pbExpandButton);
XC_API HELE WINAPI XRichEditColor_Create(int x, int y, int cx, int cy, HXCGUI hParent);
XC_API void WINAPI XRichEditColor_SetColor(HELE hEle,COLORREF color);//ɫ
XC_API COLORREF WINAPI XRichEditColor_GetColor(HELE hEle); //ȡɫRGBֵ
XC_API HELE WINAPI XRichEditSet_Create(int x, int y, int cx, int cy, HXCGUI hParent);
XC_API HELE WINAPI XRichEditFile_Create(int x, int y, int cx, int cy, HXCGUI hParent = NULL);
XC_API void WINAPI XRichEditFile_SetOpenFileType(HELE hEle,const wchar_t *pType); //ôļ
XC_API void WINAPI XRichEditFile_SetDefaultFile(HELE hEle,const wchar_t *pFile); //ĬĿ¼ļ
XC_API void WINAPI XRichEditFile_SetRelativeDir(HELE hEle,const wchar_t *pDir); //TODO:·
XC_API void WINAPI XRichEditFolder_SetDefaultDir(HELE hEle,const wchar_t* pDir);  //ĬĿ¼
XC_API HELE WINAPI XRichEdit_Create(int x, int y, int cx, int cy, HXCGUI hParent = NULL);
XC_API void WINAPI XRichEdit_InsertString(HELE hEle, UINT iRow, UINT iColumn, const wchar_t *pString);
XC_API void WINAPI XRichEdit_EnableReadOnly(HELE hEle, BOOL bEnable);
XC_API void WINAPI XRichEdit_EnableMultiLine(HELE hEle, BOOL bEnable);
XC_API void WINAPI XRichEdit_EnablePassword(HELE hEle, BOOL bEnable);
XC_API void WINAPI XRichEdit_EnableEvent_XE_RICHEDIT_CHANGE(HELE hEle,BOOL bEnable);
XC_API void WINAPI XRichEdit_SetText(HELE hEle,const wchar_t* pString);
XC_API void WINAPI XRichEdit_SetTextInt(HELE hEle,int nVaule);
XC_API int  WINAPI XRichEdit_GetText(HELE hEle,out_ wchar_t* pOut,int len);
XC_API int  WINAPI XRichEdit_GetTextLength(HELE hEle);
XC_API void WINAPI XRichEdit_SetRowHeight(HELE hEle,UINT nHeight); //Ĭи
XC_API int WINAPI XRichEdit_GetCurrentRow(HELE hEle);
XC_API int WINAPI XRichEdit_GetCurrentColumn(HELE hEle);
XC_API int WINAPI XRichEdit_GetRowCount(HELE hEle);
XC_API int WINAPI XRichEdit_GetRowLength(HELE hEle,int iRow);
XC_API int WINAPI XRichEdit_GetSelectText(HELE hEle,out_ wchar_t* pOut,int len);
XC_API void WINAPI XRichEdit_CancelSelect(HELE hEle);
XC_API void WINAPI XRichEdit_SetSelectBkColor(HELE hEle,COLORREF color,BYTE alpha=255);
XC_API BOOL WINAPI XRichEdit_isEmpty(HELE hEle);
XC_API BOOL WINAPI XRichEdit_SelectAll(HELE hEle);    //ѡ
XC_API BOOL WINAPI XRichEdit_DeleteSelect(HELE hEle); //ɾѡ
XC_API void WINAPI XRichEdit_DeleteAll(HELE hEle);    //ɾ
XC_API BOOL WINAPI XRichEdit_ClipboardCopy(HELE hEle);     // ѡ
XC_API BOOL WINAPI XRichEdit_ClipboardPaste(HELE hEle);    //ճ ճ
XC_API HELE WINAPI XSBar_Create(int x, int y, int cx, int cy, HXCGUI hParent = NULL);
XC_API void WINAPI XSBar_SetRange(HELE hEle, int range);
XC_API int  WINAPI XSBar_GetRange(HELE hEle);
XC_API void  WINAPI XSBar_ShowButton(HELE hEle, BOOL bShow);
XC_API void WINAPI XSBar_SetSliderLength(HELE hEle, int length); //û鳤
XC_API void WINAPI XSBar_SetSliderMinLength(HELE hEle, int minLength); //ûС
XC_API BOOL WINAPI XSBar_SetHorizon(HELE hEle, BOOL bHorizon);  //ˮƽʾֱ
XC_API int  WINAPI XSBar_GetSliderMaxLength(HELE hEle);
XC_API BOOL WINAPI XSBar_ScrollUp(HELE hEle);       //
XC_API BOOL WINAPI XSBar_ScrollDown(HELE hEle);     //ҹ
XC_API BOOL WINAPI XSBar_ScrollTop(HELE hEle);      //
XC_API BOOL WINAPI XSBar_ScrollBottom(HELE hEle);   //ײ
XC_API BOOL WINAPI XSBar_ScrollPos(HELE hEle, int pos); //ָ
XC_API HELE WINAPI XSBar_GetButtonUp(HELE hEle);
XC_API HELE WINAPI XSBar_GetButtonDown(HELE hEle);
XC_API HELE WINAPI XSBar_GetButtonSlider(HELE hEle);
XC_API HELE WINAPI XSView_Create(int x, int y, int cx, int cy, HXCGUI hParent = NULL);
XC_API BOOL WINAPI XSView_SetTotalSize(HELE hEle, int cx, int cy); //ͼܴС(߿)
XC_API void WINAPI XSView_GetTotalSize(HELE hEle, SIZE *pSize);  //ȡõݴС
XC_API BOOL WINAPI XSView_SetLineSize(HELE hEle,int nHeight,int nWidth);
XC_API void WINAPI XSView_GetLineSize(HELE hEle,out_ SIZE *pSize);
XC_API int  WINAPI XSView_GetViewPosH(HELE hEle);   //ȡӿԭX
XC_API int  WINAPI XSView_GetViewPosV(HELE hEle);   //ȡӿԭY
XC_API int  WINAPI XSView_GetViewWidth(HELE hEle); 
XC_API int  WINAPI XSView_GetViewHeight(HELE hEle);
XC_API void WINAPI XSView_GetViewRect(HELE hEle, out_ RECT *pRect); //ȡӿ(߿),leftΪӿС,topΪӿϼС,(0,0).
XC_API HELE WINAPI XSView_GetScrollBarH(HELE hEle); //ȡˮƽ
XC_API HELE WINAPI XSView_GetScrollBarV(HELE hEle); //ȡֱ
XC_API void WINAPI XSView_SetPadding(HELE hEle, int left,int top,int right,int bottom);
XC_API void WINAPI XSView_GetPadding(HELE hEle, out_ PaddingSize_* pPadding);
XC_API BOOL WINAPI XSView_ScrollPosH(HELE hEle, int pos); //ָ
XC_API BOOL WINAPI XSView_ScrollPosV(HELE hEle, int pos); //ָ
XC_API BOOL WINAPI XSView_ScrollPosXH(HELE hEle, int posX); //ָ
XC_API BOOL WINAPI XSView_ScrollPosYV(HELE hEle, int posY); //ָ
XC_API void WINAPI XSView_ShowSBarH(HELE hEle,BOOL bShow); //ˮƽ
XC_API void WINAPI XSView_ShowSBarV(HELE hEle,BOOL bShow); //ôֱ
XC_API void WINAPI XSView_EnableAutoShowScrollBar(HELE hEle,BOOL bEnable);	
XC_API BOOL WINAPI XSView_ScrollLeftLine(HELE hEle);    //
XC_API BOOL WINAPI XSView_ScrollRightLine(HELE hEle);   //ҹ
XC_API BOOL WINAPI XSView_ScrollTopLine(HELE hEle);     //Ϲ
XC_API BOOL WINAPI XSView_ScrollDownLine(HELE hEle);    //¹
XC_API BOOL WINAPI XSView_ScrollLeft(HELE hEle);    //ˮƽ
XC_API BOOL WINAPI XSView_ScrollRight(HELE hEle);   //ˮƽҲ
XC_API BOOL WINAPI XSView_ScrollTop(HELE hEle);     //
XC_API BOOL WINAPI XSView_ScrollBottom(HELE hEle);  //ײ
XC_API HELE WINAPI XShape_GetParentEle(HXCGUI hShape);
XC_API HXCGUI WINAPI XShape_GetParentLayout(HXCGUI hShape);
XC_API void WINAPI XShape_SetID(HXCGUI hShape,int nID);
XC_API int  WINAPI XShape_GetID(HXCGUI hShape);
XC_API void WINAPI XShape_Redraw(HXCGUI hShape);
XC_API int  WINAPI XShape_GetWidth(HXCGUI hShape);
XC_API int  WINAPI XShape_GetHeight(HXCGUI hShape);
XC_API void WINAPI XShape_GetRect(HXCGUI hShape,out_ RECT* pRect);
XC_API void WINAPI XShape_SetRect(HXCGUI hShape,in_  RECT* pRect);
XC_API void WINAPI XShape_GetContentSize(HXCGUI hShape,out_ SIZE* pSize);//ȡݴС
XC_API void WINAPI XShape_ShowLayout(HXCGUI hShape,BOOL bShow);
XC_API void WINAPI XShape_AdjustLayout(HXCGUI hShape);
XC_API void WINAPI XShape_Destroy(HXCGUI hShape);
XC_API HXCGUI WINAPI XTextBlock_Create(int x, int y, int cx, int cy, const wchar_t *pName,HXCGUI hParent=NULL);
XC_API void  WINAPI XTextBlock_SetText(HXCGUI hTextBlock,const wchar_t *pName);
XC_API void  WINAPI XTextBlock_SetFont(HXCGUI hTextBlock,HFONTX hFontx);
XC_API void WINAPI XTextBlock_SetTextColor(HXCGUI hTextBlock, COLORREF color,BYTE alpha);
XC_API COLORREF WINAPI XTextBlock_GetTextColor(HXCGUI hTextBlock);
XC_API void WINAPI XTextBlock_SetTextAlign(HXCGUI hTextBlock,int align);
XC_API void WINAPI XTextBlock_SetOffset(HXCGUI hTextBlock,int x,int y);
XC_API void WINAPI XTextBlock_SetLayoutWidth(HXCGUI hTextBlock,int nFlag,int width);
XC_API void WINAPI XTextBlock_SetLayoutHeight(HXCGUI hTextBlock,int nFlag,int height);
XC_API void WINAPI XTextBlock_GetLayoutWidth(HXCGUI hTextBlock,out_ int *pFlag,out_ int *pWidth);
XC_API void WINAPI XTextBlock_GetLayoutHeight(HXCGUI hTextBlock,out_ int *pFlag,out_ int *pHeight);
XC_API HXCGUI WINAPI XShapePic_Create(int x,int y,int cx,int cy, HXCGUI hParent=NULL);
XC_API void WINAPI   XShapePic_SetImage(HXCGUI hShape,HIMAGE hImage);
XC_API void WINAPI XShapePic_SetLayoutWidth(HXCGUI hShape,int nFlag,int width);
XC_API void WINAPI XShapePic_SetLayoutHeight(HXCGUI hShape,int nFlag,int height);
XC_API void WINAPI XShapePic_GetLayoutWidth(HXCGUI hShape,out_ int *pFlag,out_ int *pWidth);
XC_API void WINAPI XShapePic_GetLayoutHeight(HXCGUI hShape,out_ int *pFlag,out_ int *pHeight);
XC_API HXCGUI WINAPI XShapeRect_Create(int x,int y,int cx,int cy, HXCGUI hParent=NULL);
XC_API void WINAPI XShapeRect_SetBorderColor(HXCGUI hShape,COLORREF color,BYTE alpha=255);
XC_API void WINAPI XShapeRect_SetFillColor(HXCGUI hShape,COLORREF color,BYTE alpha=255);
XC_API void WINAPI XShapeRect_SetRoundAngle(HXCGUI hShape,int nWidth, int nHeight);
XC_API void WINAPI XShapeRect_GetRoundAngle(HXCGUI hShape,out_ int *pWidth,out_ int *pHeight);
XC_API void WINAPI XShapeRect_EnableBorder(HXCGUI hShape,BOOL bEnable);
XC_API void WINAPI XShapeRect_EnableFill(HXCGUI hShape,BOOL bEnable);
XC_API void WINAPI XShapeRect_EnableRoundAngle(HXCGUI hShape,BOOL bEnable);
XC_API HXCGUI WINAPI XShapeEllipse_Create(int x,int y,int cx,int cy, HXCGUI hParent=NULL);
XC_API void WINAPI XShapeEllipse_SetBorderColor(HXCGUI hShape,COLORREF color,BYTE alpha=255);
XC_API void WINAPI XShapeEllipse_SetFillColor(HXCGUI hShape,COLORREF color,BYTE alpha=255);
XC_API void WINAPI XShapeEllipse_EnableBorder(HXCGUI hShape,BOOL bEnable);
XC_API void WINAPI XShapeEllipse_EnableFill(HXCGUI hShape,BOOL bEnable);
XC_API HXCGUI WINAPI XShapeGroupBox_Create(int x,int y,int cx,int cy,const wchar_t* pName,HXCGUI hParent=NULL);
XC_API void WINAPI XShapeGroupBox_SetBorderColor(HXCGUI hShape,COLORREF color,BYTE alpha=255);
XC_API void WINAPI XShapeGroupBox_SetTextColor(HXCGUI hShape,COLORREF color,BYTE alpha=254);
XC_API void WINAPI XShapeGroupBox_SetFontX(HXCGUI hShape,HFONTX hFontX);
XC_API void WINAPI XShapeGroupBox_SetTextOffset(HXCGUI hShape,int offsetX,int offsetY);
XC_API void WINAPI XShapeGroupBox_SetRoundAngle(HXCGUI hShape,int nWidth, int nHeight);
XC_API void WINAPI XShapeGroupBox_SetText(HXCGUI hShape,const wchar_t* pText);
XC_API void WINAPI XShapeGroupBox_GetTextOffset(HXCGUI hShape,out_ int *pOffsetX,out_ int *pOffsetY);
XC_API void WINAPI XShapeGroupBox_GetRoundAngle(HXCGUI hShape,out_ int *pWidth,out_ int *pHeight);
XC_API void WINAPI XShapeGroupBox_EnableRoundAngle(HXCGUI hShape,BOOL bEnable);
XC_API HXCGUI WINAPI XShapeLine_Create(int x1,int y1,int x2,int y2, HXCGUI hParent=NULL);
XC_API void WINAPI XShapeLine_SetPosition(HXCGUI hShape,int x1,int y1,int x2,int y2);
XC_API void WINAPI XShapeLine_SetColor(HXCGUI hShape,COLORREF color,BYTE alpha);
XC_API HELE WINAPI XSliderBar_Create(int x, int y, int cx, int cy,HXCGUI hParent=NULL);
XC_API void WINAPI XSliderBar_SetRange(HELE hEle,int range);
XC_API int  WINAPI XSliderBar_GetRange(HELE hEle);
XC_API void WINAPI XSliderBar_SetButtonWidth(HELE hEle,int width);
XC_API void WINAPI XSliderBar_SetButtonHeight(HELE hEle,int height);
XC_API void WINAPI XSliderBar_SetSpaceTwo(HELE hEle,int leftSize,int rightSize);
XC_API void WINAPI XSliderBar_SetPos(HELE hEle,int pos);
XC_API int  WINAPI XSliderBar_GetPos(HELE hEle);
XC_API HELE WINAPI XSliderBar_GetButton(HELE hEle);
XC_API void WINAPI XSliderBar_SetHorizon(HELE hEle,BOOL bHorizon);
XC_API void WINAPI XSliderBar_SetImageLoad(HELE hEle,HIMAGE hImage);
XC_API HELE WINAPI XTabBar_Create(int x, int y, int cx, int cy, HXCGUI hParent = NULL);
XC_API int  WINAPI XTabBar_AddLabel(HELE hEle,const wchar_t *pName); //һǩ
XC_API int  WINAPI XTabBar_InsertLabel(HELE hEle,int index,wchar_t *pName);
XC_API BOOL WINAPI XTabBar_DeleteLabel(HELE hEle,int index);  //ɾ
XC_API void WINAPI XTabBar_DeleteLabelAll(HELE hEle);  //ɾTAB
XC_API HELE WINAPI XTabBar_GetLabel(HELE hEle,int index);//ȡǩťButton
XC_API int  WINAPI XTabBar_GetSelect(HELE hEle);  //ȡѡıǩ
XC_API int  WINAPI XTabBar_GetLabelSpacing(HELE hEle); //ȡǩ, 0ûм
XC_API int  WINAPI XTabBar_GetLabelCount(HELE hEle); //ȡǩ
XC_API void WINAPI XTabBar_SetLabelSpacing(HELE hEle,int spacing);//ñǩ, 0ûм
XC_API void WINAPI XTabBar_SetSelect(HELE hEle,int index);   //ѡǩ
XC_API void WINAPI XTabBar_SetUp(HELE hEle);    //
XC_API void WINAPI XTabBar_SetDown(HELE hEle);  //ҹ
XC_API void WINAPI XTabBar_EnableTile(HELE hEle, BOOL bTile);  //ƽ̱ǩ,ÿǩʾͬС
XC_API void WINAPI XTabBar_EnableClose(HELE hEle, BOOL bEnable);
XC_API void WINAPI XTabBar_SetCloseSize(HELE hEle, SIZE *pSize);
XC_API void WINAPI XTabBar_SetTurnButtonSize(HELE hEle, SIZE *pSize);
XC_API HELE WINAPI XTextLink_Create(int x, int y, int cx, int cy,const wchar_t* pName, HXCGUI hParent = NULL);
XC_API void WINAPI XTextLink_EnableUnderlineLeave(HELE hEle,BOOL bEnable);
XC_API void WINAPI XTextLink_EnableUnderlineStay(HELE hEle,BOOL bEnable);
XC_API void WINAPI XTextLink_SetTextColorStay(HELE hEle,COLORREF color,BYTE alpha);
XC_API void WINAPI XTextLink_SetUnderlineColorLeave(HELE hEle,COLORREF color,BYTE alpha);
XC_API void WINAPI XTextLink_SetUnderlineColorStay(HELE hEle,COLORREF color,BYTE alpha);
XC_API HELE WINAPI XToolBar_Create(int x, int y, int cx, int cy,HXCGUI hParent=NULL);
XC_API int WINAPI XToolBar_InsertEle(HELE hEle,HELE hNewEle,int index=-1); //Ԫص, -1뵽ĩβ
XC_API int WINAPI XToolBar_InsertSeparator(HELE hEle,int index=-1); //ӷָ, -1뵽ĩβ
XC_API void WINAPI XToolBar_EnableButtonMenu(HELE hEle,BOOL bEnable);  //ʾ˵ť
XC_API HELE WINAPI XToolBar_GetHEle(HELE hEle,int index);  //ȡԪؾ
XC_API HELE WINAPI XToolBar_GetButtonLeft(HELE hEle);   //ȡťButton
XC_API HELE WINAPI XToolBar_GetButtonRight(HELE hEle);  //ȡҹťButton
XC_API HELE WINAPI XToolBar_GetButtonMenu(HELE hEle);   //ȡ˵ť
XC_API void WINAPI XToolBar_DeleteEle(HELE hEle,int index); //ƳԪز
XC_API void WINAPI XToolBar_DeleteAllEle(HELE hEle);
XC_API HELE WINAPI XTree_Create(int x,int y,int cx,int cy,HXCGUI hParent=NULL);
XC_API BOOL WINAPI XTree_SetItemTemplateXML(HELE hEle,const wchar_t* pXmlFile);
XC_API BOOL WINAPI XTree_SetItemTemplateXMLSel(HELE hEle,const wchar_t* pXmlFile);
XC_API void WINAPI XTree_SetStyle(HELE hEle,int style);
XC_API BOOL WINAPI XTree_SetItemData(HELE hEle,int nID,int nUserData);
XC_API int  WINAPI XTree_GetItemData(HELE hEle,int nID);
XC_API BOOL WINAPI XTree_SetSelectItem(HELE hEle,int nID);
XC_API int  WINAPI XTree_GetSelectItem(HELE hEle);
XC_API BOOL WINAPI XTree_IsExpand (HELE hEle,int nID);
XC_API BOOL WINAPI XTree_ExpandItem(HELE hEle,int nID,BOOL bExpand);
XC_API int  WINAPI XTree_HitTest(HELE hEle,POINT *pPt);
XC_API int  WINAPI XTree_HitTestOffet(HELE hEle,POINT *pPt);
XC_API int  WINAPI XTree_GetFirstChildItem(HELE hEle,int nID);
XC_API int  WINAPI XTree_GetNextSiblingItem(HELE hEle,int nID);
XC_API void WINAPI XTree_SetIndentation(HELE hEle,int nWidth);
XC_API int  WINAPI XTree_GetIndentation(HELE hEle);
XC_API void WINAPI XTree_SetItemHeightDefault(HELE hEle,int nHeight,int nSelHeight);
XC_API void WINAPI XTree_GetItemHeightDefault(HELE hEle,out_ int *pHeight,out_ int *pSelHeight);
XC_API void WINAPI XTree_SetItemHeight(HELE hEle,int nID,int nHeight,int nSelHeight);
XC_API void WINAPI XTree_GetItemHeight(HELE hEle,int nID,out_ int *pHeight,out_ int *pSelHeight);
XC_API void WINAPI XTree_SetItemColor(HELE hEle,COLORREF color,BYTE alpha=255);
XC_API void WINAPI XTree_SetItemColorSel(HELE hEle,COLORREF color,BYTE alpha=255);
XC_API COLORREF WINAPI XTree_GetItemColor(HELE hEle);
XC_API COLORREF WINAPI XTree_GetItemColorSel(HELE hEle);
XC_API HXCGUI  WINAPI XTree_GetTemplateObject(HELE hEle,int nID,int nTempItemID); //ͨģID,ȡʵģIDӦĶ.
XC_API void WINAPI XTree_BindAdapter(HELE hEle,HXCGUI hAdapter);
XC_API HXCGUI WINAPI XTree_GetAdapter(HELE hEle);
XC_API void WINAPI XWnd_RegEventEx(HWINDOW hWindow, CEventBase* pEvent);
XC_API BOOL WINAPI XWnd_RemoveEventEx(HWINDOW hWindow,CEventBase *pEvent);
XC_API void WINAPI XWnd_RegEvent(HWINDOW hWindow, int nEvent, void *pFun);
XC_API BOOL WINAPI XWnd_RemovegEvent(HWINDOW hWindow, int nEvent, void *pFun);
XC_API HWINDOW WINAPI XWnd_Create(int x, int y, int cx, int cy, wchar_t *pTitle, HWND hWndParent = NULL, int XCStyle = XC_SY_DEFAULT);
XC_API HWINDOW WINAPI XWnd_CreateEx(DWORD dwExStyle, wchar_t* lpClassName, wchar_t* lpWindowName, DWORD dwStyle, int x, int y, int cx, int cy, HWND hWndParent=NULL, int XCStyle=XC_SY_DEFAULT);
XC_API BOOL WINAPI XWnd_AddEle(HWINDOW hWindow, HELE hEle);
XC_API BOOL WINAPI XWnd_InsertEle(HWINDOW hWindow, HELE hChildEle,HELE hDestEle);
XC_API BOOL WINAPI XWnd_AddShape(HWINDOW hWindow, HXCGUI hShape);
XC_API HWND WINAPI XWnd_GetHWND(HWINDOW hWindow);
XC_API void WINAPI XWnd_EnableDragBorder(HWINDOW hWindow, BOOL bEnable);
XC_API void WINAPI XWnd_EnableDragWindow(HWINDOW hWindow, BOOL bEnable);
XC_API void WINAPI XWnd_EnableDrawBk(HWINDOW hWindow,BOOL bEnable);
XC_API void WINAPI XWnd_RedrawWnd(HWINDOW hWindow);
XC_API void WINAPI XWnd_RedrawWndRect(HWINDOW hWindow, RECT *pRect, BOOL bImmediately = FALSE); //ػ洰ָ
XC_API void WINAPI XWnd_SetFocusEle(HWINDOW hWindow, HELE hFocusEle);
XC_API HELE WINAPI XWnd_GetFocusEle(HWINDOW hWindow);
XC_API void WINAPI XWnd_SetCursor(HWINDOW hWindow,HCURSOR hCursor);
XC_API HCURSOR WINAPI XWnd_GetCursor(HWINDOW hWindow);
XC_API HCURSOR WINAPI XWnd_SetCursorSys(HWINDOW hWindow,HCURSOR hCursor);
XC_API void WINAPI XWnd_SetFont(HWINDOW hWindow,HFONTX hFontx);
XC_API void WINAPI XWnd_SetID(HWINDOW hWindow, int nID);
XC_API int  WINAPI XWnd_GetID(HWINDOW hWindow);
XC_API void WINAPI XWnd_SetCaptureEle(HWINDOW hWindow, HELE hEle);
XC_API HELE WINAPI XWnd_GetCaptureEle(HWINDOW hWindow);
XC_API BOOL WINAPI XWnd_SetLayoutEle(HWINDOW hWindow,int nFlag, HELE hEle);
XC_API HELE WINAPI XWnd_GetLayoutEle(HWINDOW hWindow,int nFlag);
XC_API void WINAPI XWnd_BindLayoutObject(HWINDOW hWindow,int nFlag,HXCGUI hLayout);
XC_API HXCGUI WINAPI XWnd_GetLayoutObject(HWINDOW hWindow,int nFlag);
XC_API void WINAPI XWnd_SetLayoutBkColor(HWINDOW hWindow,int nFlag,COLORREF color,BYTE alpha=255);
XC_API void WINAPI XWnd_SetLayoutSize(HWINDOW hWindow,int left, int top, int right, int bottom);
XC_API void WINAPI XWnd_GetLayoutSize(HWINDOW hWindow,out_ BorderSize_  *pBorderSize);
XC_API void WINAPI XWnd_SetDragBorderSize(HWINDOW hWindow,int left, int top, int right, int bottom); //϶߿С
XC_API void WINAPI XWnd_GetDragBorderSize(HWINDOW hWindow,out_ BorderSize_* pSize);
XC_API void WINAPI XWnd_SetMinimumSize(HWINDOW hWindow,int width,int height);
XC_API HELE WINAPI XWnd_HitChildEle(HWINDOW hWindow,POINT *pPt);
XC_API int  WINAPI XWnd_GetChildCount(HWINDOW hWindow);
XC_API HELE WINAPI XWnd_GetChildByIndex(HWINDOW hWindow,int index);
XC_API HELE WINAPI XWnd_GetChildByID(HWINDOW hWindow,int nID);
XC_API HELE WINAPI XWnd_GetEle(HWINDOW hWindow,int nID);
XC_API void WINAPI XWnd_GetDrawRect(HWINDOW hWindow,RECT *pRcPaint);
XC_API BOOL WINAPI XWnd_ShowWindow(HWINDOW hWindow, int nCmdShow);
XC_API void WINAPI XWnd_AdjustLayout(HWINDOW hWindow);
XC_API void WINAPI XWnd_CloseWindow(HWINDOW hWindow);
XC_API void WINAPI XWnd_CreateCaret(HWINDOW hWindow, HELE hEle, int width, int height);//
XC_API void WINAPI XWnd_SetCaretSize(HWINDOW hWindow, int width, int height); //òС
XC_API void WINAPI XWnd_SetCaretPos(HWINDOW hWindow, int x, int y); //òλ
XC_API void WINAPI XWnd_SetCaretPosEx(HWINDOW hWindow, int x, int y, int width, int height); //òλ
XC_API void WINAPI XWnd_SetCaretColor(HWINDOW hWindow, COLORREF color); //òɫ
XC_API void WINAPI XWnd_ShowCaret(HWINDOW hWindow, BOOL bShow);  //ʾ
XC_API void WINAPI XWnd_DestroyCaret(HWINDOW hWindow);    //ٲ
XC_API HELE WINAPI XWnd_GetCaretHELE(HWINDOW hWindow);
XC_API BOOL WINAPI XWnd_GetClientRect(HWINDOW hWindow, out_ RECT *pRect); //ȡͻ
XC_API void WINAPI XWnd_GetBodyRect(HWINDOW hWindow, out_ RECT *pRect);  //ȡbody
XC_API UINT WINAPI XWnd_SetTimer(HWINDOW hWindow, UINT nIDEvent, UINT uElapse); //öʱ
XC_API BOOL WINAPI XWnd_KillTimer(HWINDOW hWindow, UINT nIDEvent);
XC_API void WINAPI XWnd_SetImage(HWINDOW hWindow, HIMAGE hImage);
XC_API void WINAPI XWnd_SetImageLayout(HWINDOW hWindow, HIMAGE hImage,int nFlag);
XC_API void WINAPI XWnd_SetTransparentFlag(HWINDOW hWindow,int nFlag);  //͸
XC_API void WINAPI XWnd_SetTransparentAlpha(HWINDOW hWindow,BYTE alpha); //ô͸
XC_API void WINAPI XWnd_SetTransparentColor(HWINDOW hWindow,COLORREF color); //ô͸ɫ
XC_API BOOL WINAPI XWnd_RegEventTest(int nEvent,BYTE* pParamType);

